"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function readFromText(filePattern) {
    return _tct_transform_1 = async function readFromText(root) {
        return root.applyAsync(pythonTransform("apache_beam.io.ReadFromText", {
            file_pattern: filePattern,
        }));
    }, _tct_transform_1.__closure = () => ({ pythonTransform, filePattern }), _tct_transform_1;
}
var _tct_transform_1, _tct_transform_2, _tct_transform_3, _tct_transform_4, _tct_transform_5, _tct_transform_6;
readFromText.__closure = () => ({ pythonTransform });
function writeToText(filePathPrefix, options = {}) {
    return _tct_transform_2 = async function writeToText(pcoll) {
        return {
            filesWritten: await pcoll
                .map((e) => (typeof e == "string" ? e : "" + e))
                .apply(withCoderInternal(new StrUtf8Coder()))
                .applyAsync(pythonTransform("apache_beam.io.WriteToText", {
                file_path_prefix: filePathPrefix,
                ...camelToSnakeOptions(options),
            })),
        };
    }, _tct_transform_2.__closure = () => ({ withCoderInternal, StrUtf8Coder, pythonTransform, filePathPrefix, camelToSnakeOptions, options }), _tct_transform_2;
}
writeToText.__closure = () => ({ withCoderInternal, StrUtf8Coder, pythonTransform, camelToSnakeOptions });
function readFromCsv(filePattern, options = {}) {
    return _tct_transform_3 = async function readFromCsv(root) {
        return root.applyAsync(pythonTransform("apache_beam.dataframe.io.ReadViaPandas", {
            path: filePattern,
            format: "csv",
            ...camelToSnakeOptions(options),
        }));
    }, _tct_transform_3.__closure = () => ({ pythonTransform, filePattern, camelToSnakeOptions, options }), _tct_transform_3;
}
readFromCsv.__closure = () => ({ pythonTransform, camelToSnakeOptions });
function writeToCsv(filePathPrefix, schema = undefined, options = {}) {
    return _tct_transform_4 = async function writeToCsv(toWrite) {
        if (schema != undefined) {
            toWrite = toWrite.apply(withCoderInternal(RowCoder.fromSchema(schema)));
        }
        return {
            filesWritten: await toWrite.applyAsync(pythonTransform("apache_beam.dataframe.io.WriteViaPandas", {
                path: filePathPrefix,
                format: "csv",
                index: false,
                ...camelToSnakeOptions(options),
            })),
        };
    }, _tct_transform_4.__closure = () => ({ schema, withCoderInternal, RowCoder, pythonTransform, filePathPrefix, camelToSnakeOptions, options }), _tct_transform_4;
}
writeToCsv.__closure = () => ({ withCoderInternal, RowCoder, pythonTransform, camelToSnakeOptions });
function readFromJson(filePattern, options = {}) {
    return _tct_transform_5 = async function readFromJson(root) {
        return root.applyAsync(pythonTransform("apache_beam.dataframe.io.ReadViaPandas", {
            path: filePattern,
            format: "json",
            orient: "records",
            lines: true,
            ...camelToSnakeOptions(options),
        }));
    }, _tct_transform_5.__closure = () => ({ pythonTransform, filePattern, camelToSnakeOptions, options }), _tct_transform_5;
}
readFromJson.__closure = () => ({ pythonTransform, camelToSnakeOptions });
function writeToJson(filePathPrefix, schema = undefined, options = {}) {
    return _tct_transform_6 = async function writeToJson(toWrite) {
        if (schema != undefined) {
            toWrite = toWrite.apply(withCoderInternal(RowCoder.fromSchema(schema)));
        }
        return {
            filesWritten: await toWrite.applyAsync(pythonTransform("apache_beam.dataframe.io.WriteViaPandas", {
                path: filePathPrefix,
                format: "json",
                orient: "records",
                lines: true,
                ...camelToSnakeOptions(options),
            })),
        };
    }, _tct_transform_6.__closure = () => ({ schema, withCoderInternal, RowCoder, pythonTransform, filePathPrefix, camelToSnakeOptions, options }), _tct_transform_6;
}
writeToJson.__closure = () => ({ withCoderInternal, RowCoder, pythonTransform, camelToSnakeOptions });
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeToJson = exports.readFromJson = exports.writeToCsv = exports.readFromCsv = exports.writeToText = exports.readFromText = void 0;
const _tct_flatten_destructured_imports_1 = __importStar(require("../../apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../coders/standard_coders"));
var StrUtf8Coder = _tct_flatten_destructured_imports_2.StrUtf8Coder;
const _tct_flatten_destructured_imports_3 = __importStar(require("../transforms/external"));
var external = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../transforms/internal"));
var withCoderInternal = _tct_flatten_destructured_imports_4.withCoderInternal;
const _tct_flatten_destructured_imports_5 = __importStar(require("../transforms/python"));
var pythonTransform = _tct_flatten_destructured_imports_5.pythonTransform;
const _tct_flatten_destructured_imports_6 = __importStar(require("../utils/service"));
var PythonService = _tct_flatten_destructured_imports_6.PythonService;
const _tct_flatten_destructured_imports_7 = __importStar(require("../utils/utils"));
var camelToSnakeOptions = _tct_flatten_destructured_imports_7.camelToSnakeOptions;
const _tct_flatten_destructured_imports_8 = __importStar(require("../proto/schema"));
var Schema = _tct_flatten_destructured_imports_8.Schema;
const _tct_flatten_destructured_imports_9 = __importStar(require("../coders/row_coder"));
var RowCoder = _tct_flatten_destructured_imports_9.RowCoder;
exports.readFromText = readFromText;
exports.writeToText = writeToText;
exports.readFromCsv = readFromCsv;
exports.writeToCsv = writeToCsv;
exports.readFromJson = readFromJson;
exports.writeToJson = writeToJson;
//# sourceMappingURL=textio.js.map