import type { ArtifactChunk } from "./beam_artifact_api";
import type { LegacyGetArtifactRequest } from "./beam_artifact_api";
import type { GetManifestResponse } from "./beam_artifact_api";
import type { GetManifestRequest } from "./beam_artifact_api";
import type { CommitManifestResponse } from "./beam_artifact_api";
import type { CommitManifestRequest } from "./beam_artifact_api";
import type { PutArtifactResponse } from "./beam_artifact_api";
import type { PutArtifactRequest } from "./beam_artifact_api";
import type { ClientStreamingCall } from "@protobuf-ts/runtime-rpc";
import type { ArtifactRequestWrapper } from "./beam_artifact_api";
import type { ArtifactResponseWrapper } from "./beam_artifact_api";
import type { DuplexStreamingCall } from "@protobuf-ts/runtime-rpc";
import type { RpcTransport } from "@protobuf-ts/runtime-rpc";
import type { ServiceInfo } from "@protobuf-ts/runtime-rpc";
import type { GetArtifactResponse } from "./beam_artifact_api";
import type { GetArtifactRequest } from "./beam_artifact_api";
import type { ServerStreamingCall } from "@protobuf-ts/runtime-rpc";
import type { ResolveArtifactsResponse } from "./beam_artifact_api";
import type { ResolveArtifactsRequest } from "./beam_artifact_api";
import type { UnaryCall } from "@protobuf-ts/runtime-rpc";
import type { RpcOptions } from "@protobuf-ts/runtime-rpc";
/**
 * A service to retrieve artifacts for use in a Job.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.ArtifactRetrievalService
 */
export interface IArtifactRetrievalServiceClient {
    /**
     * Resolves the given artifact references into one or more replacement
     * artifact references (e.g. a Maven dependency into a (transitive) set
     * of jars.
     *
     * @generated from protobuf rpc: ResolveArtifacts(org.apache.beam.model.job_management.v1.ResolveArtifactsRequest) returns (org.apache.beam.model.job_management.v1.ResolveArtifactsResponse);
     */
    resolveArtifacts(input: ResolveArtifactsRequest, options?: RpcOptions): UnaryCall<ResolveArtifactsRequest, ResolveArtifactsResponse>;
    /**
     * Retrieves the given artifact as a stream of bytes.
     *
     * @generated from protobuf rpc: GetArtifact(org.apache.beam.model.job_management.v1.GetArtifactRequest) returns (stream org.apache.beam.model.job_management.v1.GetArtifactResponse);
     */
    getArtifact(input: GetArtifactRequest, options?: RpcOptions): ServerStreamingCall<GetArtifactRequest, GetArtifactResponse>;
}
/**
 * A service to retrieve artifacts for use in a Job.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.ArtifactRetrievalService
 */
export declare class ArtifactRetrievalServiceClient implements IArtifactRetrievalServiceClient, ServiceInfo {
    private readonly _transport;
    typeName: string;
    methods: import("@protobuf-ts/runtime-rpc").MethodInfo<any, any>[];
    options: {
        [extensionName: string]: import("@protobuf-ts/runtime").JsonValue;
    };
    constructor(_transport: RpcTransport);
    /**
     * Resolves the given artifact references into one or more replacement
     * artifact references (e.g. a Maven dependency into a (transitive) set
     * of jars.
     *
     * @generated from protobuf rpc: ResolveArtifacts(org.apache.beam.model.job_management.v1.ResolveArtifactsRequest) returns (org.apache.beam.model.job_management.v1.ResolveArtifactsResponse);
     */
    resolveArtifacts(input: ResolveArtifactsRequest, options?: RpcOptions): UnaryCall<ResolveArtifactsRequest, ResolveArtifactsResponse>;
    /**
     * Retrieves the given artifact as a stream of bytes.
     *
     * @generated from protobuf rpc: GetArtifact(org.apache.beam.model.job_management.v1.GetArtifactRequest) returns (stream org.apache.beam.model.job_management.v1.GetArtifactResponse);
     */
    getArtifact(input: GetArtifactRequest, options?: RpcOptions): ServerStreamingCall<GetArtifactRequest, GetArtifactResponse>;
}
/**
 * A service that allows the client to act as an ArtifactRetrievalService,
 * for a particular job with the server initiating requests and receiving
 * responses.
 *
 * A client calls the service with an ArtifactResponseWrapper that has the
 * staging token set, and thereafter responds to the server's requests.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.ArtifactStagingService
 */
export interface IArtifactStagingServiceClient {
    /**
     * @generated from protobuf rpc: ReverseArtifactRetrievalService(stream org.apache.beam.model.job_management.v1.ArtifactResponseWrapper) returns (stream org.apache.beam.model.job_management.v1.ArtifactRequestWrapper);
     */
    reverseArtifactRetrievalService(options?: RpcOptions): DuplexStreamingCall<ArtifactResponseWrapper, ArtifactRequestWrapper>;
}
/**
 * A service that allows the client to act as an ArtifactRetrievalService,
 * for a particular job with the server initiating requests and receiving
 * responses.
 *
 * A client calls the service with an ArtifactResponseWrapper that has the
 * staging token set, and thereafter responds to the server's requests.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.ArtifactStagingService
 */
export declare class ArtifactStagingServiceClient implements IArtifactStagingServiceClient, ServiceInfo {
    private readonly _transport;
    typeName: string;
    methods: import("@protobuf-ts/runtime-rpc").MethodInfo<any, any>[];
    options: {
        [extensionName: string]: import("@protobuf-ts/runtime").JsonValue;
    };
    constructor(_transport: RpcTransport);
    /**
     * @generated from protobuf rpc: ReverseArtifactRetrievalService(stream org.apache.beam.model.job_management.v1.ArtifactResponseWrapper) returns (stream org.apache.beam.model.job_management.v1.ArtifactRequestWrapper);
     */
    reverseArtifactRetrievalService(options?: RpcOptions): DuplexStreamingCall<ArtifactResponseWrapper, ArtifactRequestWrapper>;
}
/**
 * A service to stage artifacts for use in a Job.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.LegacyArtifactStagingService
 */
export interface ILegacyArtifactStagingServiceClient {
    /**
     * Stage an artifact to be available during job execution. The first request must contain the
     * name of the artifact. All future requests must contain sequential chunks of the content of
     * the artifact.
     *
     * @generated from protobuf rpc: PutArtifact(stream org.apache.beam.model.job_management.v1.PutArtifactRequest) returns (org.apache.beam.model.job_management.v1.PutArtifactResponse);
     */
    putArtifact(options?: RpcOptions): ClientStreamingCall<PutArtifactRequest, PutArtifactResponse>;
    /**
     * Commit the manifest for a Job. All artifacts must have been successfully uploaded
     * before this call is made.
     *
     * Throws error INVALID_ARGUMENT if not all of the members of the manifest are present
     *
     * @generated from protobuf rpc: CommitManifest(org.apache.beam.model.job_management.v1.CommitManifestRequest) returns (org.apache.beam.model.job_management.v1.CommitManifestResponse);
     */
    commitManifest(input: CommitManifestRequest, options?: RpcOptions): UnaryCall<CommitManifestRequest, CommitManifestResponse>;
}
/**
 * A service to stage artifacts for use in a Job.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.LegacyArtifactStagingService
 */
export declare class LegacyArtifactStagingServiceClient implements ILegacyArtifactStagingServiceClient, ServiceInfo {
    private readonly _transport;
    typeName: string;
    methods: import("@protobuf-ts/runtime-rpc").MethodInfo<any, any>[];
    options: {
        [extensionName: string]: import("@protobuf-ts/runtime").JsonValue;
    };
    constructor(_transport: RpcTransport);
    /**
     * Stage an artifact to be available during job execution. The first request must contain the
     * name of the artifact. All future requests must contain sequential chunks of the content of
     * the artifact.
     *
     * @generated from protobuf rpc: PutArtifact(stream org.apache.beam.model.job_management.v1.PutArtifactRequest) returns (org.apache.beam.model.job_management.v1.PutArtifactResponse);
     */
    putArtifact(options?: RpcOptions): ClientStreamingCall<PutArtifactRequest, PutArtifactResponse>;
    /**
     * Commit the manifest for a Job. All artifacts must have been successfully uploaded
     * before this call is made.
     *
     * Throws error INVALID_ARGUMENT if not all of the members of the manifest are present
     *
     * @generated from protobuf rpc: CommitManifest(org.apache.beam.model.job_management.v1.CommitManifestRequest) returns (org.apache.beam.model.job_management.v1.CommitManifestResponse);
     */
    commitManifest(input: CommitManifestRequest, options?: RpcOptions): UnaryCall<CommitManifestRequest, CommitManifestResponse>;
}
/**
 * A service to retrieve artifacts for use in a Job.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.LegacyArtifactRetrievalService
 */
export interface ILegacyArtifactRetrievalServiceClient {
    /**
     * Get the manifest for the job
     *
     * @generated from protobuf rpc: GetManifest(org.apache.beam.model.job_management.v1.GetManifestRequest) returns (org.apache.beam.model.job_management.v1.GetManifestResponse);
     */
    getManifest(input: GetManifestRequest, options?: RpcOptions): UnaryCall<GetManifestRequest, GetManifestResponse>;
    /**
     * Get an artifact staged for the job. The requested artifact must be within the manifest
     *
     * @generated from protobuf rpc: GetArtifact(org.apache.beam.model.job_management.v1.LegacyGetArtifactRequest) returns (stream org.apache.beam.model.job_management.v1.ArtifactChunk);
     */
    getArtifact(input: LegacyGetArtifactRequest, options?: RpcOptions): ServerStreamingCall<LegacyGetArtifactRequest, ArtifactChunk>;
}
/**
 * A service to retrieve artifacts for use in a Job.
 *
 * @generated from protobuf service org.apache.beam.model.job_management.v1.LegacyArtifactRetrievalService
 */
export declare class LegacyArtifactRetrievalServiceClient implements ILegacyArtifactRetrievalServiceClient, ServiceInfo {
    private readonly _transport;
    typeName: string;
    methods: import("@protobuf-ts/runtime-rpc").MethodInfo<any, any>[];
    options: {
        [extensionName: string]: import("@protobuf-ts/runtime").JsonValue;
    };
    constructor(_transport: RpcTransport);
    /**
     * Get the manifest for the job
     *
     * @generated from protobuf rpc: GetManifest(org.apache.beam.model.job_management.v1.GetManifestRequest) returns (org.apache.beam.model.job_management.v1.GetManifestResponse);
     */
    getManifest(input: GetManifestRequest, options?: RpcOptions): UnaryCall<GetManifestRequest, GetManifestResponse>;
    /**
     * Get an artifact staged for the job. The requested artifact must be within the manifest
     *
     * @generated from protobuf rpc: GetArtifact(org.apache.beam.model.job_management.v1.LegacyGetArtifactRequest) returns (stream org.apache.beam.model.job_management.v1.ArtifactChunk);
     */
    getArtifact(input: LegacyGetArtifactRequest, options?: RpcOptions): ServerStreamingCall<LegacyGetArtifactRequest, ArtifactChunk>;
}
