import type { WorkerStatusRequest } from "./beam_fn_api";
import type { WorkerStatusResponse } from "./beam_fn_api";
import type { StopWorkerResponse } from "./beam_fn_api";
import type { StopWorkerRequest } from "./beam_fn_api";
import type { StartWorkerResponse } from "./beam_fn_api";
import type { StartWorkerRequest } from "./beam_fn_api";
import type { LogControl } from "./beam_fn_api";
import type { LogEntry_List } from "./beam_fn_api";
import type { StateResponse } from "./beam_fn_api";
import type { StateRequest } from "./beam_fn_api";
import type { Elements } from "./beam_fn_api";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { ProcessBundleDescriptor } from "./beam_fn_api";
import type { GetProcessBundleDescriptorRequest } from "./beam_fn_api";
import type { InstructionRequest } from "./beam_fn_api";
import type { InstructionResponse } from "./beam_fn_api";
import * as grpc from "@grpc/grpc-js";
/**
 * An API that describes the work that a SDK harness is meant to do.
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnControl
 */
export interface IBeamFnControlClient {
    /**
     * Instructions sent by the runner to the SDK requesting different types
     * of work.
     *
     * @generated from protobuf rpc: Control(stream org.apache.beam.model.fn_execution.v1.InstructionResponse) returns (stream org.apache.beam.model.fn_execution.v1.InstructionRequest);
     */
    control(metadata: grpc.Metadata, options?: grpc.CallOptions): grpc.ClientDuplexStream<InstructionResponse, InstructionRequest>;
    control(options?: grpc.CallOptions): grpc.ClientDuplexStream<InstructionResponse, InstructionRequest>;
    /**
     * Used to get the full process bundle descriptors for bundles one
     * is asked to process.
     *
     * @generated from protobuf rpc: GetProcessBundleDescriptor(org.apache.beam.model.fn_execution.v1.GetProcessBundleDescriptorRequest) returns (org.apache.beam.model.fn_execution.v1.ProcessBundleDescriptor);
     */
    getProcessBundleDescriptor(input: GetProcessBundleDescriptorRequest, metadata: grpc.Metadata, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: ProcessBundleDescriptor) => void): grpc.ClientUnaryCall;
    getProcessBundleDescriptor(input: GetProcessBundleDescriptorRequest, metadata: grpc.Metadata, callback: (err: grpc.ServiceError | null, value?: ProcessBundleDescriptor) => void): grpc.ClientUnaryCall;
    getProcessBundleDescriptor(input: GetProcessBundleDescriptorRequest, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: ProcessBundleDescriptor) => void): grpc.ClientUnaryCall;
    getProcessBundleDescriptor(input: GetProcessBundleDescriptorRequest, callback: (err: grpc.ServiceError | null, value?: ProcessBundleDescriptor) => void): grpc.ClientUnaryCall;
}
/**
 * An API that describes the work that a SDK harness is meant to do.
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnControl
 */
export declare class BeamFnControlClient extends grpc.Client implements IBeamFnControlClient {
    private readonly _binaryOptions;
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: grpc.ClientOptions, binaryOptions?: Partial<BinaryReadOptions & BinaryWriteOptions>);
    /**
     * Instructions sent by the runner to the SDK requesting different types
     * of work.
     *
     * @generated from protobuf rpc: Control(stream org.apache.beam.model.fn_execution.v1.InstructionResponse) returns (stream org.apache.beam.model.fn_execution.v1.InstructionRequest);
     */
    control(metadata?: grpc.Metadata | grpc.CallOptions, options?: grpc.CallOptions): grpc.ClientDuplexStream<InstructionResponse, InstructionRequest>;
    /**
     * Used to get the full process bundle descriptors for bundles one
     * is asked to process.
     *
     * @generated from protobuf rpc: GetProcessBundleDescriptor(org.apache.beam.model.fn_execution.v1.GetProcessBundleDescriptorRequest) returns (org.apache.beam.model.fn_execution.v1.ProcessBundleDescriptor);
     */
    getProcessBundleDescriptor(input: GetProcessBundleDescriptorRequest, metadata: grpc.Metadata | grpc.CallOptions | ((err: grpc.ServiceError | null, value?: ProcessBundleDescriptor) => void), options?: grpc.CallOptions | ((err: grpc.ServiceError | null, value?: ProcessBundleDescriptor) => void), callback?: ((err: grpc.ServiceError | null, value?: ProcessBundleDescriptor) => void)): grpc.ClientUnaryCall;
}
/**
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnData
 */
export interface IBeamFnDataClient {
    /**
     * Used to send data between harnesses.
     *
     * @generated from protobuf rpc: Data(stream org.apache.beam.model.fn_execution.v1.Elements) returns (stream org.apache.beam.model.fn_execution.v1.Elements);
     */
    data(metadata: grpc.Metadata, options?: grpc.CallOptions): grpc.ClientDuplexStream<Elements, Elements>;
    data(options?: grpc.CallOptions): grpc.ClientDuplexStream<Elements, Elements>;
}
/**
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnData
 */
export declare class BeamFnDataClient extends grpc.Client implements IBeamFnDataClient {
    private readonly _binaryOptions;
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: grpc.ClientOptions, binaryOptions?: Partial<BinaryReadOptions & BinaryWriteOptions>);
    /**
     * Used to send data between harnesses.
     *
     * @generated from protobuf rpc: Data(stream org.apache.beam.model.fn_execution.v1.Elements) returns (stream org.apache.beam.model.fn_execution.v1.Elements);
     */
    data(metadata?: grpc.Metadata | grpc.CallOptions, options?: grpc.CallOptions): grpc.ClientDuplexStream<Elements, Elements>;
}
/**
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnState
 */
export interface IBeamFnStateClient {
    /**
     * Used to get/append/clear state stored by the runner on behalf of the SDK.
     *
     * @generated from protobuf rpc: State(stream org.apache.beam.model.fn_execution.v1.StateRequest) returns (stream org.apache.beam.model.fn_execution.v1.StateResponse);
     */
    state(metadata: grpc.Metadata, options?: grpc.CallOptions): grpc.ClientDuplexStream<StateRequest, StateResponse>;
    state(options?: grpc.CallOptions): grpc.ClientDuplexStream<StateRequest, StateResponse>;
}
/**
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnState
 */
export declare class BeamFnStateClient extends grpc.Client implements IBeamFnStateClient {
    private readonly _binaryOptions;
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: grpc.ClientOptions, binaryOptions?: Partial<BinaryReadOptions & BinaryWriteOptions>);
    /**
     * Used to get/append/clear state stored by the runner on behalf of the SDK.
     *
     * @generated from protobuf rpc: State(stream org.apache.beam.model.fn_execution.v1.StateRequest) returns (stream org.apache.beam.model.fn_execution.v1.StateResponse);
     */
    state(metadata?: grpc.Metadata | grpc.CallOptions, options?: grpc.CallOptions): grpc.ClientDuplexStream<StateRequest, StateResponse>;
}
/**
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnLogging
 */
export interface IBeamFnLoggingClient {
    /**
     * Allows for the SDK to emit log entries which the runner can
     * associate with the active job.
     *
     * @generated from protobuf rpc: Logging(stream org.apache.beam.model.fn_execution.v1.LogEntry.List) returns (stream org.apache.beam.model.fn_execution.v1.LogControl);
     */
    logging(metadata: grpc.Metadata, options?: grpc.CallOptions): grpc.ClientDuplexStream<LogEntry_List, LogControl>;
    logging(options?: grpc.CallOptions): grpc.ClientDuplexStream<LogEntry_List, LogControl>;
}
/**
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnLogging
 */
export declare class BeamFnLoggingClient extends grpc.Client implements IBeamFnLoggingClient {
    private readonly _binaryOptions;
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: grpc.ClientOptions, binaryOptions?: Partial<BinaryReadOptions & BinaryWriteOptions>);
    /**
     * Allows for the SDK to emit log entries which the runner can
     * associate with the active job.
     *
     * @generated from protobuf rpc: Logging(stream org.apache.beam.model.fn_execution.v1.LogEntry.List) returns (stream org.apache.beam.model.fn_execution.v1.LogControl);
     */
    logging(metadata?: grpc.Metadata | grpc.CallOptions, options?: grpc.CallOptions): grpc.ClientDuplexStream<LogEntry_List, LogControl>;
}
/**
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnExternalWorkerPool
 */
export interface IBeamFnExternalWorkerPoolClient {
    /**
     * Start the SDK worker with the given ID.
     *
     * @generated from protobuf rpc: StartWorker(org.apache.beam.model.fn_execution.v1.StartWorkerRequest) returns (org.apache.beam.model.fn_execution.v1.StartWorkerResponse);
     */
    startWorker(input: StartWorkerRequest, metadata: grpc.Metadata, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: StartWorkerResponse) => void): grpc.ClientUnaryCall;
    startWorker(input: StartWorkerRequest, metadata: grpc.Metadata, callback: (err: grpc.ServiceError | null, value?: StartWorkerResponse) => void): grpc.ClientUnaryCall;
    startWorker(input: StartWorkerRequest, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: StartWorkerResponse) => void): grpc.ClientUnaryCall;
    startWorker(input: StartWorkerRequest, callback: (err: grpc.ServiceError | null, value?: StartWorkerResponse) => void): grpc.ClientUnaryCall;
    /**
     * Stop the SDK worker.
     *
     * @generated from protobuf rpc: StopWorker(org.apache.beam.model.fn_execution.v1.StopWorkerRequest) returns (org.apache.beam.model.fn_execution.v1.StopWorkerResponse);
     */
    stopWorker(input: StopWorkerRequest, metadata: grpc.Metadata, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: StopWorkerResponse) => void): grpc.ClientUnaryCall;
    stopWorker(input: StopWorkerRequest, metadata: grpc.Metadata, callback: (err: grpc.ServiceError | null, value?: StopWorkerResponse) => void): grpc.ClientUnaryCall;
    stopWorker(input: StopWorkerRequest, options: grpc.CallOptions, callback: (err: grpc.ServiceError | null, value?: StopWorkerResponse) => void): grpc.ClientUnaryCall;
    stopWorker(input: StopWorkerRequest, callback: (err: grpc.ServiceError | null, value?: StopWorkerResponse) => void): grpc.ClientUnaryCall;
}
/**
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnExternalWorkerPool
 */
export declare class BeamFnExternalWorkerPoolClient extends grpc.Client implements IBeamFnExternalWorkerPoolClient {
    private readonly _binaryOptions;
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: grpc.ClientOptions, binaryOptions?: Partial<BinaryReadOptions & BinaryWriteOptions>);
    /**
     * Start the SDK worker with the given ID.
     *
     * @generated from protobuf rpc: StartWorker(org.apache.beam.model.fn_execution.v1.StartWorkerRequest) returns (org.apache.beam.model.fn_execution.v1.StartWorkerResponse);
     */
    startWorker(input: StartWorkerRequest, metadata: grpc.Metadata | grpc.CallOptions | ((err: grpc.ServiceError | null, value?: StartWorkerResponse) => void), options?: grpc.CallOptions | ((err: grpc.ServiceError | null, value?: StartWorkerResponse) => void), callback?: ((err: grpc.ServiceError | null, value?: StartWorkerResponse) => void)): grpc.ClientUnaryCall;
    /**
     * Stop the SDK worker.
     *
     * @generated from protobuf rpc: StopWorker(org.apache.beam.model.fn_execution.v1.StopWorkerRequest) returns (org.apache.beam.model.fn_execution.v1.StopWorkerResponse);
     */
    stopWorker(input: StopWorkerRequest, metadata: grpc.Metadata | grpc.CallOptions | ((err: grpc.ServiceError | null, value?: StopWorkerResponse) => void), options?: grpc.CallOptions | ((err: grpc.ServiceError | null, value?: StopWorkerResponse) => void), callback?: ((err: grpc.ServiceError | null, value?: StopWorkerResponse) => void)): grpc.ClientUnaryCall;
}
/**
 * API for SDKs to report debug-related statuses to runner during pipeline execution.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnWorkerStatus
 */
export interface IBeamFnWorkerStatusClient {
    /**
     * @generated from protobuf rpc: WorkerStatus(stream org.apache.beam.model.fn_execution.v1.WorkerStatusResponse) returns (stream org.apache.beam.model.fn_execution.v1.WorkerStatusRequest);
     */
    workerStatus(metadata: grpc.Metadata, options?: grpc.CallOptions): grpc.ClientDuplexStream<WorkerStatusResponse, WorkerStatusRequest>;
    workerStatus(options?: grpc.CallOptions): grpc.ClientDuplexStream<WorkerStatusResponse, WorkerStatusRequest>;
}
/**
 * API for SDKs to report debug-related statuses to runner during pipeline execution.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnWorkerStatus
 */
export declare class BeamFnWorkerStatusClient extends grpc.Client implements IBeamFnWorkerStatusClient {
    private readonly _binaryOptions;
    constructor(address: string, credentials: grpc.ChannelCredentials, options?: grpc.ClientOptions, binaryOptions?: Partial<BinaryReadOptions & BinaryWriteOptions>);
    /**
     * @generated from protobuf rpc: WorkerStatus(stream org.apache.beam.model.fn_execution.v1.WorkerStatusResponse) returns (stream org.apache.beam.model.fn_execution.v1.WorkerStatusRequest);
     */
    workerStatus(metadata?: grpc.Metadata | grpc.CallOptions, options?: grpc.CallOptions): grpc.ClientDuplexStream<WorkerStatusResponse, WorkerStatusRequest>;
}
