import { WorkerStatusRequest } from "./beam_fn_api";
import { WorkerStatusResponse } from "./beam_fn_api";
import { StopWorkerResponse } from "./beam_fn_api";
import { StopWorkerRequest } from "./beam_fn_api";
import { StartWorkerResponse } from "./beam_fn_api";
import { StartWorkerRequest } from "./beam_fn_api";
import { LogControl } from "./beam_fn_api";
import { LogEntry_List } from "./beam_fn_api";
import { StateResponse } from "./beam_fn_api";
import { StateRequest } from "./beam_fn_api";
import { Elements } from "./beam_fn_api";
import { ProcessBundleDescriptor } from "./beam_fn_api";
import { GetProcessBundleDescriptorRequest } from "./beam_fn_api";
import { InstructionRequest } from "./beam_fn_api";
import { InstructionResponse } from "./beam_fn_api";
import * as grpc from "@grpc/grpc-js";
/**
 * An API that describes the work that a SDK harness is meant to do.
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnControl
 */
export interface IBeamFnControl extends grpc.UntypedServiceImplementation {
    /**
     * Instructions sent by the runner to the SDK requesting different types
     * of work.
     *
     * @generated from protobuf rpc: Control(stream org.apache.beam.model.fn_execution.v1.InstructionResponse) returns (stream org.apache.beam.model.fn_execution.v1.InstructionRequest);
     */
    control: grpc.handleBidiStreamingCall<InstructionResponse, InstructionRequest>;
    /**
     * Used to get the full process bundle descriptors for bundles one
     * is asked to process.
     *
     * @generated from protobuf rpc: GetProcessBundleDescriptor(org.apache.beam.model.fn_execution.v1.GetProcessBundleDescriptorRequest) returns (org.apache.beam.model.fn_execution.v1.ProcessBundleDescriptor);
     */
    getProcessBundleDescriptor: grpc.handleUnaryCall<GetProcessBundleDescriptorRequest, ProcessBundleDescriptor>;
}
/**
 * @grpc/grpc-js definition for the protobuf service org.apache.beam.model.fn_execution.v1.BeamFnControl.
 *
 * Usage: Implement the interface IBeamFnControl and add to a grpc server.
 *
 * ```typescript
 * const server = new grpc.Server();
 * const service: IBeamFnControl = ...
 * server.addService(beamFnControlDefinition, service);
 * ```
 */
export declare const beamFnControlDefinition: grpc.ServiceDefinition<IBeamFnControl>;
/**
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnData
 */
export interface IBeamFnData extends grpc.UntypedServiceImplementation {
    /**
     * Used to send data between harnesses.
     *
     * @generated from protobuf rpc: Data(stream org.apache.beam.model.fn_execution.v1.Elements) returns (stream org.apache.beam.model.fn_execution.v1.Elements);
     */
    data: grpc.handleBidiStreamingCall<Elements, Elements>;
}
/**
 * @grpc/grpc-js definition for the protobuf service org.apache.beam.model.fn_execution.v1.BeamFnData.
 *
 * Usage: Implement the interface IBeamFnData and add to a grpc server.
 *
 * ```typescript
 * const server = new grpc.Server();
 * const service: IBeamFnData = ...
 * server.addService(beamFnDataDefinition, service);
 * ```
 */
export declare const beamFnDataDefinition: grpc.ServiceDefinition<IBeamFnData>;
/**
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnState
 */
export interface IBeamFnState extends grpc.UntypedServiceImplementation {
    /**
     * Used to get/append/clear state stored by the runner on behalf of the SDK.
     *
     * @generated from protobuf rpc: State(stream org.apache.beam.model.fn_execution.v1.StateRequest) returns (stream org.apache.beam.model.fn_execution.v1.StateResponse);
     */
    state: grpc.handleBidiStreamingCall<StateRequest, StateResponse>;
}
/**
 * @grpc/grpc-js definition for the protobuf service org.apache.beam.model.fn_execution.v1.BeamFnState.
 *
 * Usage: Implement the interface IBeamFnState and add to a grpc server.
 *
 * ```typescript
 * const server = new grpc.Server();
 * const service: IBeamFnState = ...
 * server.addService(beamFnStateDefinition, service);
 * ```
 */
export declare const beamFnStateDefinition: grpc.ServiceDefinition<IBeamFnState>;
/**
 * Stable
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnLogging
 */
export interface IBeamFnLogging extends grpc.UntypedServiceImplementation {
    /**
     * Allows for the SDK to emit log entries which the runner can
     * associate with the active job.
     *
     * @generated from protobuf rpc: Logging(stream org.apache.beam.model.fn_execution.v1.LogEntry.List) returns (stream org.apache.beam.model.fn_execution.v1.LogControl);
     */
    logging: grpc.handleBidiStreamingCall<LogEntry_List, LogControl>;
}
/**
 * @grpc/grpc-js definition for the protobuf service org.apache.beam.model.fn_execution.v1.BeamFnLogging.
 *
 * Usage: Implement the interface IBeamFnLogging and add to a grpc server.
 *
 * ```typescript
 * const server = new grpc.Server();
 * const service: IBeamFnLogging = ...
 * server.addService(beamFnLoggingDefinition, service);
 * ```
 */
export declare const beamFnLoggingDefinition: grpc.ServiceDefinition<IBeamFnLogging>;
/**
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnExternalWorkerPool
 */
export interface IBeamFnExternalWorkerPool extends grpc.UntypedServiceImplementation {
    /**
     * Start the SDK worker with the given ID.
     *
     * @generated from protobuf rpc: StartWorker(org.apache.beam.model.fn_execution.v1.StartWorkerRequest) returns (org.apache.beam.model.fn_execution.v1.StartWorkerResponse);
     */
    startWorker: grpc.handleUnaryCall<StartWorkerRequest, StartWorkerResponse>;
    /**
     * Stop the SDK worker.
     *
     * @generated from protobuf rpc: StopWorker(org.apache.beam.model.fn_execution.v1.StopWorkerRequest) returns (org.apache.beam.model.fn_execution.v1.StopWorkerResponse);
     */
    stopWorker: grpc.handleUnaryCall<StopWorkerRequest, StopWorkerResponse>;
}
/**
 * @grpc/grpc-js definition for the protobuf service org.apache.beam.model.fn_execution.v1.BeamFnExternalWorkerPool.
 *
 * Usage: Implement the interface IBeamFnExternalWorkerPool and add to a grpc server.
 *
 * ```typescript
 * const server = new grpc.Server();
 * const service: IBeamFnExternalWorkerPool = ...
 * server.addService(beamFnExternalWorkerPoolDefinition, service);
 * ```
 */
export declare const beamFnExternalWorkerPoolDefinition: grpc.ServiceDefinition<IBeamFnExternalWorkerPool>;
/**
 * API for SDKs to report debug-related statuses to runner during pipeline execution.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.BeamFnWorkerStatus
 */
export interface IBeamFnWorkerStatus extends grpc.UntypedServiceImplementation {
    /**
     * @generated from protobuf rpc: WorkerStatus(stream org.apache.beam.model.fn_execution.v1.WorkerStatusResponse) returns (stream org.apache.beam.model.fn_execution.v1.WorkerStatusRequest);
     */
    workerStatus: grpc.handleBidiStreamingCall<WorkerStatusResponse, WorkerStatusRequest>;
}
/**
 * @grpc/grpc-js definition for the protobuf service org.apache.beam.model.fn_execution.v1.BeamFnWorkerStatus.
 *
 * Usage: Implement the interface IBeamFnWorkerStatus and add to a grpc server.
 *
 * ```typescript
 * const server = new grpc.Server();
 * const service: IBeamFnWorkerStatus = ...
 * server.addService(beamFnWorkerStatusDefinition, service);
 * ```
 */
export declare const beamFnWorkerStatusDefinition: grpc.ServiceDefinition<IBeamFnWorkerStatus>;
