import { ServiceType } from "@protobuf-ts/runtime-rpc";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
import { ArtifactInformation } from "../../pipeline/v1/beam_runner_api";
import { ApiServiceDescriptor } from "../../pipeline/v1/endpoints";
import { Struct } from "../../../../../../google/protobuf/struct";
/**
 * A request to get the provision info of a SDK harness worker instance.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.GetProvisionInfoRequest
 */
export interface GetProvisionInfoRequest {
}
/**
 * A response containing the provision info of a SDK harness worker instance.
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.GetProvisionInfoResponse
 */
export interface GetProvisionInfoResponse {
    /**
     * @generated from protobuf field: org.apache.beam.model.fn_execution.v1.ProvisionInfo info = 1;
     */
    info?: ProvisionInfo;
}
/**
 * Runtime provisioning information for a SDK harness worker instance,
 * such as pipeline options, resource constraints and other job metadata
 *
 * @generated from protobuf message org.apache.beam.model.fn_execution.v1.ProvisionInfo
 */
export interface ProvisionInfo {
    /**
     * (required) Pipeline options. For non-template jobs, the options are
     * identical to what is passed to job submission.
     *
     * @generated from protobuf field: google.protobuf.Struct pipeline_options = 3;
     */
    pipelineOptions?: Struct;
    /**
     * (required) The artifact retrieval token produced by
     * LegacyArtifactStagingService.CommitManifestResponse.
     *
     * @generated from protobuf field: string retrieval_token = 6;
     */
    retrievalToken: string;
    /**
     * (optional) The endpoint that the runner is hosting for the SDK to submit
     * status reports to during pipeline execution. This field will only be
     * populated if the runner supports SDK status reports. For more details see
     * https://s.apache.org/beam-fn-api-harness-status
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor status_endpoint = 7;
     */
    statusEndpoint?: ApiServiceDescriptor;
    /**
     * (optional) The logging endpoint this SDK should use.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor logging_endpoint = 8;
     */
    loggingEndpoint?: ApiServiceDescriptor;
    /**
     * (optional) The artifact retrieval endpoint this SDK should use.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor artifact_endpoint = 9;
     */
    artifactEndpoint?: ApiServiceDescriptor;
    /**
     * (optional) The control endpoint this SDK should use.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ApiServiceDescriptor control_endpoint = 10;
     */
    controlEndpoint?: ApiServiceDescriptor;
    /**
     * The set of dependencies that should be staged into this environment.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.ArtifactInformation dependencies = 11;
     */
    dependencies: ArtifactInformation[];
    /**
     * (optional) A set of capabilities that this SDK is allowed to use in its
     * interactions with this runner.
     *
     * @generated from protobuf field: repeated string runner_capabilities = 12;
     */
    runnerCapabilities: string[];
    /**
     * (optional) Runtime environment metadata that are static throughout the
     * pipeline execution.
     *
     * @generated from protobuf field: map<string, string> metadata = 13;
     */
    metadata: {
        [key: string]: string;
    };
    /**
     * (optional) If this environment supports SIBLING_WORKERS, used to indicate
     * the ids of sibling workers, if any, that should be started in addition
     * to this worker (which already has its own worker id).
     *
     * @generated from protobuf field: repeated string sibling_worker_ids = 14;
     */
    siblingWorkerIds: string[];
}
declare class GetProvisionInfoRequest$Type extends MessageType<GetProvisionInfoRequest> {
    constructor();
    create(value?: PartialMessage<GetProvisionInfoRequest>): GetProvisionInfoRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GetProvisionInfoRequest): GetProvisionInfoRequest;
    internalBinaryWrite(message: GetProvisionInfoRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.GetProvisionInfoRequest
 */
export declare const GetProvisionInfoRequest: GetProvisionInfoRequest$Type;
declare class GetProvisionInfoResponse$Type extends MessageType<GetProvisionInfoResponse> {
    constructor();
    create(value?: PartialMessage<GetProvisionInfoResponse>): GetProvisionInfoResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: GetProvisionInfoResponse): GetProvisionInfoResponse;
    internalBinaryWrite(message: GetProvisionInfoResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.GetProvisionInfoResponse
 */
export declare const GetProvisionInfoResponse: GetProvisionInfoResponse$Type;
declare class ProvisionInfo$Type extends MessageType<ProvisionInfo> {
    constructor();
    create(value?: PartialMessage<ProvisionInfo>): ProvisionInfo;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ProvisionInfo): ProvisionInfo;
    private binaryReadMap13;
    internalBinaryWrite(message: ProvisionInfo, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.fn_execution.v1.ProvisionInfo
 */
export declare const ProvisionInfo: ProvisionInfo$Type;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.fn_execution.v1.ProvisionService
 */
export declare const ProvisionService: ServiceType;
export {};
