import { GetProvisionInfoResponse } from "./beam_provision_api";
import { GetProvisionInfoRequest } from "./beam_provision_api";
import * as grpc from "@grpc/grpc-js";
/**
 * A service to provide runtime provisioning information to the SDK harness
 * worker instances -- such as pipeline options, resource constraints and
 * other job metadata -- needed by an SDK harness instance to initialize.
 *
 * @generated from protobuf service org.apache.beam.model.fn_execution.v1.ProvisionService
 */
export interface IProvisionService extends grpc.UntypedServiceImplementation {
    /**
     * Get provision information for the SDK harness worker instance.
     *
     * @generated from protobuf rpc: GetProvisionInfo(org.apache.beam.model.fn_execution.v1.GetProvisionInfoRequest) returns (org.apache.beam.model.fn_execution.v1.GetProvisionInfoResponse);
     */
    getProvisionInfo: grpc.handleUnaryCall<GetProvisionInfoRequest, GetProvisionInfoResponse>;
}
/**
 * @grpc/grpc-js definition for the protobuf service org.apache.beam.model.fn_execution.v1.ProvisionService.
 *
 * Usage: Implement the interface IProvisionService and add to a grpc server.
 *
 * ```typescript
 * const server = new grpc.Server();
 * const service: IProvisionService = ...
 * server.addService(provisionServiceDefinition, service);
 * ```
 */
export declare const provisionServiceDefinition: grpc.ServiceDefinition<IProvisionService>;
