import { ServiceType } from "@protobuf-ts/runtime-rpc";
import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
import { PTransform } from "../../pipeline/v1/beam_runner_api";
import { Components } from "../../pipeline/v1/beam_runner_api";
/**
 * @generated from protobuf message org.apache.beam.model.expansion.v1.ExpansionRequest
 */
export interface ExpansionRequest {
    /**
     * Set of components needed to interpret the transform, or which
     * may be useful for its expansion.  This includes the input
     * PCollections (if any) to the to-be-expanded transform, along
     * with their coders and windowing strategies.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.Components components = 1;
     */
    components?: Components;
    /**
     * The actual PTransform to be expaneded according to its spec.
     * Its input should be set, but its subtransforms and outputs
     * should not be.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.PTransform transform = 2;
     */
    transform?: PTransform;
    /**
     * A namespace (prefix) to use for the id of any newly created
     * components.
     *
     * @generated from protobuf field: string namespace = 3;
     */
    namespace: string;
    /**
     * (Optional) Map from a local output tag to a coder id.
     * If it is set, asks the expansion service to use the given
     * coders for the output PCollections. Note that the request
     * may not be fulfilled.
     *
     * @generated from protobuf field: map<string, string> output_coder_requests = 4;
     */
    outputCoderRequests: {
        [key: string]: string;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.expansion.v1.ExpansionResponse
 */
export interface ExpansionResponse {
    /**
     * Set of components needed to execute the expanded transform,
     * including the (original) inputs, outputs, and subtransforms.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.Components components = 1;
     */
    components?: Components;
    /**
     * The expanded transform itself, with references to its outputs
     * and subtransforms.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.PTransform transform = 2;
     */
    transform?: PTransform;
    /**
     * A set of requirements that must be appended to this pipeline's
     * requirements.
     *
     * @generated from protobuf field: repeated string requirements = 3;
     */
    requirements: string[];
    /**
     * (Optional) An string representation of any error encountered while
     * attempting to expand this transform.
     *
     * @generated from protobuf field: string error = 10;
     */
    error: string;
}
declare class ExpansionRequest$Type extends MessageType<ExpansionRequest> {
    constructor();
    create(value?: PartialMessage<ExpansionRequest>): ExpansionRequest;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ExpansionRequest): ExpansionRequest;
    private binaryReadMap4;
    internalBinaryWrite(message: ExpansionRequest, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.expansion.v1.ExpansionRequest
 */
export declare const ExpansionRequest: ExpansionRequest$Type;
declare class ExpansionResponse$Type extends MessageType<ExpansionResponse> {
    constructor();
    create(value?: PartialMessage<ExpansionResponse>): ExpansionResponse;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ExpansionResponse): ExpansionResponse;
    internalBinaryWrite(message: ExpansionResponse, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.expansion.v1.ExpansionResponse
 */
export declare const ExpansionResponse: ExpansionResponse$Type;
/**
 * @generated ServiceType for protobuf service org.apache.beam.model.expansion.v1.ExpansionService
 */
export declare const ExpansionService: ServiceType;
export {};
