import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
/**
 * A description of how to connect to a Beam API endpoint.
 *
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.ApiServiceDescriptor
 */
export interface ApiServiceDescriptor {
    /**
     * (Required) The URL to connect to.
     *
     * @generated from protobuf field: string url = 1;
     */
    url: string;
    /**
     * (Optional) The method for authentication. If unspecified, access to the
     * url is already being performed in a trusted context (e.g. localhost,
     * private network).
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.AuthenticationSpec authentication = 2;
     */
    authentication?: AuthenticationSpec;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.AuthenticationSpec
 */
export interface AuthenticationSpec {
    /**
     * (Required) A URN that describes the accompanying payload.
     * For any URN that is not recognized (by whomever is inspecting
     * it) the parameter payload should be treated as opaque and
     * passed as-is.
     *
     * @generated from protobuf field: string urn = 1;
     */
    urn: string;
    /**
     * (Optional) The data specifying any parameters to the URN. If
     * the URN does not require any arguments, this may be omitted.
     *
     * @generated from protobuf field: bytes payload = 2;
     */
    payload: Uint8Array;
}
declare class ApiServiceDescriptor$Type extends MessageType<ApiServiceDescriptor> {
    constructor();
    create(value?: PartialMessage<ApiServiceDescriptor>): ApiServiceDescriptor;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ApiServiceDescriptor): ApiServiceDescriptor;
    internalBinaryWrite(message: ApiServiceDescriptor, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.ApiServiceDescriptor
 */
export declare const ApiServiceDescriptor: ApiServiceDescriptor$Type;
declare class AuthenticationSpec$Type extends MessageType<AuthenticationSpec> {
    constructor();
    create(value?: PartialMessage<AuthenticationSpec>): AuthenticationSpec;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: AuthenticationSpec): AuthenticationSpec;
    internalBinaryWrite(message: AuthenticationSpec, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.AuthenticationSpec
 */
export declare const AuthenticationSpec: AuthenticationSpec$Type;
export {};
