import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
import { Timestamp } from "../../../../../../google/protobuf/timestamp";
/**
 * A specification for describing a well known MonitoringInfo.
 *
 * All specifications are uniquely identified by the urn.
 *
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoSpec
 */
export interface MonitoringInfoSpec {
    /**
     * Defines the semantic meaning of the metric or monitored state.
     *
     * See MonitoringInfoSpecs.Enum for the set of well known metrics/monitored
     * state.
     *
     * @generated from protobuf field: string urn = 1;
     */
    urn: string;
    /**
     * Defines the required encoding and aggregation method for the payload.
     *
     * See MonitoringInfoTypeUrns.Enum for the set of well known types.
     *
     * @generated from protobuf field: string type = 2;
     */
    type: string;
    /**
     * The list of required labels for the specified urn and type.
     *
     * @generated from protobuf field: repeated string required_labels = 3;
     */
    requiredLabels: string[];
    /**
     * Extra non functional parts of the spec for descriptive purposes.
     * i.e. description, units, etc.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.Annotation annotations = 4;
     */
    annotations: Annotation[];
}
/**
 * The key name and value string of MonitoringInfo annotations.
 *
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.Annotation
 */
export interface Annotation {
    /**
     * @generated from protobuf field: string key = 1;
     */
    key: string;
    /**
     * @generated from protobuf field: string value = 2;
     */
    value: string;
}
/**
 * A set of well known MonitoringInfo specifications.
 *
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoSpecs
 */
export interface MonitoringInfoSpecs {
}
/**
 * @generated from protobuf enum org.apache.beam.model.pipeline.v1.MonitoringInfoSpecs.Enum
 */
export declare enum MonitoringInfoSpecs_Enum {
    /**
     * Represents an integer counter where values are summed across bundles.
     *
     * @generated from protobuf enum value: USER_SUM_INT64 = 0;
     */
    USER_SUM_INT64 = 0,
    /**
     * Represents a double counter where values are summed across bundles.
     *
     * @generated from protobuf enum value: USER_SUM_DOUBLE = 1;
     */
    USER_SUM_DOUBLE = 1,
    /**
     * Represents a distribution of an integer value where:
     *   - count: represents the number of values seen across all bundles
     *   - sum: represents the total of the value across all bundles
     *   - min: represents the smallest value seen across all bundles
     *   - max: represents the largest value seen across all bundles
     *
     * @generated from protobuf enum value: USER_DISTRIBUTION_INT64 = 2;
     */
    USER_DISTRIBUTION_INT64 = 2,
    /**
     * Represents a distribution of a double value where:
     *   - count: represents the number of values seen across all bundles
     *   - sum: represents the total of the value across all bundles
     *   - min: represents the smallest value seen across all bundles
     *   - max: represents the largest value seen across all bundles
     *
     * @generated from protobuf enum value: USER_DISTRIBUTION_DOUBLE = 3;
     */
    USER_DISTRIBUTION_DOUBLE = 3,
    /**
     * Represents the latest seen integer value. The timestamp is used to
     * provide an "ordering" over multiple values to determine which is the
     * latest.
     *
     * @generated from protobuf enum value: USER_LATEST_INT64 = 4;
     */
    USER_LATEST_INT64 = 4,
    /**
     * Represents the latest seen double value. The timestamp is used to
     * provide an "ordering" over multiple values to determine which is the
     * latest.
     *
     * @generated from protobuf enum value: USER_LATEST_DOUBLE = 5;
     */
    USER_LATEST_DOUBLE = 5,
    /**
     * Represents the largest set of integer values seen across bundles.
     *
     * @generated from protobuf enum value: USER_TOP_N_INT64 = 6;
     */
    USER_TOP_N_INT64 = 6,
    /**
     * Represents the largest set of double values seen across bundles.
     *
     * @generated from protobuf enum value: USER_TOP_N_DOUBLE = 7;
     */
    USER_TOP_N_DOUBLE = 7,
    /**
     * Represents the smallest set of integer values seen across bundles.
     *
     * @generated from protobuf enum value: USER_BOTTOM_N_INT64 = 8;
     */
    USER_BOTTOM_N_INT64 = 8,
    /**
     * Represents the smallest set of double values seen across bundles.
     *
     * @generated from protobuf enum value: USER_BOTTOM_N_DOUBLE = 9;
     */
    USER_BOTTOM_N_DOUBLE = 9,
    /**
     * @generated from protobuf enum value: ELEMENT_COUNT = 10;
     */
    ELEMENT_COUNT = 10,
    /**
     * @generated from protobuf enum value: SAMPLED_BYTE_SIZE = 11;
     */
    SAMPLED_BYTE_SIZE = 11,
    /**
     * @generated from protobuf enum value: START_BUNDLE_MSECS = 12;
     */
    START_BUNDLE_MSECS = 12,
    /**
     * @generated from protobuf enum value: PROCESS_BUNDLE_MSECS = 13;
     */
    PROCESS_BUNDLE_MSECS = 13,
    /**
     * @generated from protobuf enum value: FINISH_BUNDLE_MSECS = 14;
     */
    FINISH_BUNDLE_MSECS = 14,
    /**
     * @generated from protobuf enum value: TOTAL_MSECS = 15;
     */
    TOTAL_MSECS = 15,
    /**
     * All values reported across all beam:metric:ptransform_progress:.*:v1
     * metrics are of the same magnitude.
     *
     * @generated from protobuf enum value: WORK_REMAINING = 16;
     */
    WORK_REMAINING = 16,
    /**
     * All values reported across all beam:metric:ptransform_progress:.*:v1
     * metrics are of the same magnitude.
     *
     * @generated from protobuf enum value: WORK_COMPLETED = 17;
     */
    WORK_COMPLETED = 17,
    /**
     * The (0-based) index of the latest item processed from the data channel.
     * This gives an indication of the SDKs progress through the data channel,
     * and is a lower bound on where it is able to split.
     * For an SDK that processes items sequentially, this is equivalently the
     * number of items fully processed (or -1 if processing has not yet started).
     *
     * @generated from protobuf enum value: DATA_CHANNEL_READ_INDEX = 18;
     */
    DATA_CHANNEL_READ_INDEX = 18,
    /**
     * @generated from protobuf enum value: API_REQUEST_COUNT = 19;
     */
    API_REQUEST_COUNT = 19,
    /**
     * @generated from protobuf enum value: API_REQUEST_LATENCIES = 20;
     */
    API_REQUEST_LATENCIES = 20
}
/**
 * A set of properties for the MonitoringInfoLabel, this is useful to obtain
 * the proper label string for the MonitoringInfoLabel.
 *
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoLabelProps
 */
export interface MonitoringInfoLabelProps {
    /**
     * The label key to use in the MonitoringInfo labels map.
     *
     * @generated from protobuf field: string name = 1;
     */
    name: string;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfo
 */
export interface MonitoringInfo {
    /**
     * (Required) Defines the semantic meaning of the metric or monitored state.
     *
     * See MonitoringInfoSpecs.Enum for the set of well known metrics/monitored
     * state.
     *
     * @generated from protobuf field: string urn = 1;
     */
    urn: string;
    /**
     * (Required) Defines the encoding and aggregation method for the payload.
     *
     * See MonitoringInfoTypeUrns.Enum for the set of well known types.
     *
     * @generated from protobuf field: string type = 2;
     */
    type: string;
    /**
     * (Required) The metric or monitored state encoded as per the specification
     * defined by the type.
     *
     * @generated from protobuf field: bytes payload = 3;
     */
    payload: Uint8Array;
    /**
     * A set of key and value labels which define the scope of the metric. For
     * well known URNs, the set of required labels is provided by the associated
     * MonitoringInfoSpec.
     *
     * Either a well defined entity id for matching the enum names in
     * the MonitoringInfoLabels enum or any arbitrary label
     * set by a custom metric or user metric.
     *
     * A monitoring system is expected to be able to aggregate the metrics
     * together for all updates having the same URN and labels. Some systems such
     * as Stackdriver will be able to aggregate the metrics using a subset of the
     * provided labels
     *
     * @generated from protobuf field: map<string, string> labels = 4;
     */
    labels: {
        [key: string]: string;
    };
    /**
     * This indicates the start of the time range over which this value was
     * measured.
     * This is needed by some external metric aggregation services
     * to indicate when the reporter of the metric first began collecting the
     * cumulative value for the timeseries.
     * If the SDK Harness restarts, it should reset the start_time, and reset
     * the collection of cumulative metrics (i.e. start to count again from 0).
     * HarnessMonitoringInfos should set this start_time once, when the
     * MonitoringInfo is first reported.
     * ProcessBundle MonitoringInfos should set a start_time for each bundle.
     *
     * @generated from protobuf field: google.protobuf.Timestamp start_time = 5;
     */
    startTime?: Timestamp;
}
/**
 * @generated from protobuf enum org.apache.beam.model.pipeline.v1.MonitoringInfo.MonitoringInfoLabels
 */
export declare enum MonitoringInfo_MonitoringInfoLabels {
    /**
     * The values used for TRANSFORM, PCOLLECTION, WINDOWING_STRATEGY
     * CODER, ENVIRONMENT, etc. must always match the keys used to
     * refer to them. For actively processed bundles, these should match the
     * values within the ProcessBundleDescriptor. For job management APIs,
     * these should match values within the original pipeline representation.
     *
     * @generated from protobuf enum value: TRANSFORM = 0;
     */
    TRANSFORM = 0,
    /**
     * @generated from protobuf enum value: PCOLLECTION = 1;
     */
    PCOLLECTION = 1,
    /**
     * @generated from protobuf enum value: WINDOWING_STRATEGY = 2;
     */
    WINDOWING_STRATEGY = 2,
    /**
     * @generated from protobuf enum value: CODER = 3;
     */
    CODER = 3,
    /**
     * @generated from protobuf enum value: ENVIRONMENT = 4;
     */
    ENVIRONMENT = 4,
    /**
     * @generated from protobuf enum value: NAMESPACE = 5;
     */
    NAMESPACE = 5,
    /**
     * @generated from protobuf enum value: NAME = 6;
     */
    NAME = 6,
    /**
     * @generated from protobuf enum value: SERVICE = 7;
     */
    SERVICE = 7,
    /**
     * @generated from protobuf enum value: METHOD = 8;
     */
    METHOD = 8,
    /**
     * @generated from protobuf enum value: RESOURCE = 9;
     */
    RESOURCE = 9,
    /**
     * @generated from protobuf enum value: STATUS = 10;
     */
    STATUS = 10,
    /**
     * @generated from protobuf enum value: BIGQUERY_PROJECT_ID = 11;
     */
    BIGQUERY_PROJECT_ID = 11,
    /**
     * @generated from protobuf enum value: BIGQUERY_DATASET = 12;
     */
    BIGQUERY_DATASET = 12,
    /**
     * @generated from protobuf enum value: BIGQUERY_TABLE = 13;
     */
    BIGQUERY_TABLE = 13,
    /**
     * @generated from protobuf enum value: BIGQUERY_VIEW = 14;
     */
    BIGQUERY_VIEW = 14,
    /**
     * @generated from protobuf enum value: BIGQUERY_QUERY_NAME = 15;
     */
    BIGQUERY_QUERY_NAME = 15,
    /**
     * @generated from protobuf enum value: GCS_BUCKET = 16;
     */
    GCS_BUCKET = 16,
    /**
     * @generated from protobuf enum value: GCS_PROJECT_ID = 17;
     */
    GCS_PROJECT_ID = 17,
    /**
     * @generated from protobuf enum value: DATASTORE_PROJECT = 18;
     */
    DATASTORE_PROJECT = 18,
    /**
     * @generated from protobuf enum value: DATASTORE_NAMESPACE = 19;
     */
    DATASTORE_NAMESPACE = 19,
    /**
     * @generated from protobuf enum value: BIGTABLE_PROJECT_ID = 20;
     */
    BIGTABLE_PROJECT_ID = 20,
    /**
     * @generated from protobuf enum value: INSTANCE_ID = 21;
     */
    INSTANCE_ID = 21,
    /**
     * @generated from protobuf enum value: TABLE_ID = 22;
     */
    TABLE_ID = 22,
    /**
     * @generated from protobuf enum value: SPANNER_PROJECT_ID = 23;
     */
    SPANNER_PROJECT_ID = 23,
    /**
     * @generated from protobuf enum value: SPANNER_DATABASE_ID = 24;
     */
    SPANNER_DATABASE_ID = 24,
    /**
     * @generated from protobuf enum value: SPANNER_TABLE_ID = 25;
     */
    SPANNER_TABLE_ID = 25,
    /**
     * @generated from protobuf enum value: SPANNER_INSTANCE_ID = 26;
     */
    SPANNER_INSTANCE_ID = 26,
    /**
     * @generated from protobuf enum value: SPANNER_QUERY_NAME = 27;
     */
    SPANNER_QUERY_NAME = 27
}
/**
 * A set of well known URNs that specify the encoding and aggregation method.
 *
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoTypeUrns
 */
export interface MonitoringInfoTypeUrns {
}
/**
 * @generated from protobuf enum org.apache.beam.model.pipeline.v1.MonitoringInfoTypeUrns.Enum
 */
export declare enum MonitoringInfoTypeUrns_Enum {
    /**
     * Represents an integer counter where values are summed across bundles.
     *
     * Encoding: <value>
     *   - value: beam:coder:varint:v1
     *
     * @generated from protobuf enum value: SUM_INT64_TYPE = 0;
     */
    SUM_INT64_TYPE = 0,
    /**
     * Represents a double counter where values are summed across bundles.
     *
     * Encoding: <value>
     *   value: beam:coder:double:v1
     *
     * @generated from protobuf enum value: SUM_DOUBLE_TYPE = 1;
     */
    SUM_DOUBLE_TYPE = 1,
    /**
     * Represents a distribution of an integer value where:
     *   - count: represents the number of values seen across all bundles
     *   - sum: represents the total of the value across all bundles
     *   - min: represents the smallest value seen across all bundles
     *   - max: represents the largest value seen across all bundles
     *
     * Encoding: <count><sum><min><max>
     *   - count: beam:coder:varint:v1
     *   - sum:   beam:coder:varint:v1
     *   - min:   beam:coder:varint:v1
     *   - max:   beam:coder:varint:v1
     *
     * @generated from protobuf enum value: DISTRIBUTION_INT64_TYPE = 2;
     */
    DISTRIBUTION_INT64_TYPE = 2,
    /**
     * Represents a distribution of a double value where:
     *   - count: represents the number of values seen across all bundles
     *   - sum: represents the total of the value across all bundles
     *   - min: represents the smallest value seen across all bundles
     *   - max: represents the largest value seen across all bundles
     *
     * Encoding: <count><sum><min><max>
     *   - count: beam:coder:varint:v1
     *   - sum:   beam:coder:double:v1
     *   - min:   beam:coder:double:v1
     *   - max:   beam:coder:double:v1
     *
     * @generated from protobuf enum value: DISTRIBUTION_DOUBLE_TYPE = 3;
     */
    DISTRIBUTION_DOUBLE_TYPE = 3,
    /**
     * Represents the latest seen integer value. The timestamp is used to
     * provide an "ordering" over multiple values to determine which is the
     * latest.
     *
     * Encoding: <timestamp><value>
     *   - timestamp: beam:coder:varint:v1     (milliseconds since epoch)
     *   - value:     beam:coder:varint:v1
     *
     * @generated from protobuf enum value: LATEST_INT64_TYPE = 4;
     */
    LATEST_INT64_TYPE = 4,
    /**
     * Represents the latest seen double value. The timestamp is used to
     * provide an "ordering" over multiple values to determine which is the
     * latest.
     *
     * Encoding: <timestamp><value>
     *   - timestamp: beam:coder:varint:v1     (milliseconds since epoch)
     *   - value:     beam:coder:double:v1
     *
     * @generated from protobuf enum value: LATEST_DOUBLE_TYPE = 5;
     */
    LATEST_DOUBLE_TYPE = 5,
    /**
     * Represents the largest set of integer values seen across bundles.
     *
     * Encoding: <iter><value1><value2>...<valueN></iter>
     *   - iter:   beam:coder:iterable:v1
     *   - valueX: beam:coder:varint:v1
     *
     * @generated from protobuf enum value: TOP_N_INT64_TYPE = 6;
     */
    TOP_N_INT64_TYPE = 6,
    /**
     * Represents the largest set of double values seen across bundles.
     *
     * Encoding: <iter><value1><value2>...<valueN></iter>
     *   - iter:   beam:coder:iterable:v1
     *   - valueX: beam:coder<beam:coder:double:v1
     *
     * @generated from protobuf enum value: TOP_N_DOUBLE_TYPE = 7;
     */
    TOP_N_DOUBLE_TYPE = 7,
    /**
     * Represents the smallest set of integer values seen across bundles.
     *
     * Encoding: <iter><value1><value2>...<valueN></iter>
     *   - iter:   beam:coder:iterable:v1
     *   - valueX: beam:coder:varint:v1
     *
     * @generated from protobuf enum value: BOTTOM_N_INT64_TYPE = 8;
     */
    BOTTOM_N_INT64_TYPE = 8,
    /**
     * Represents the smallest set of double values seen across bundles.
     *
     * Encoding: <iter><value1><value2>...<valueN></iter>
     *   - iter:   beam:coder:iterable:v1
     *   - valueX: beam:coder:double:v1
     *
     * @generated from protobuf enum value: BOTTOM_N_DOUBLE_TYPE = 9;
     */
    BOTTOM_N_DOUBLE_TYPE = 9,
    /**
     * Encoding: <iter><value1><value2>...<valueN></iter>
     *   - iter:   beam:coder:iterable:v1
     *   - valueX: beam:coder:double:v1
     *
     * @generated from protobuf enum value: PROGRESS_TYPE = 10;
     */
    PROGRESS_TYPE = 10
}
declare class MonitoringInfoSpec$Type extends MessageType<MonitoringInfoSpec> {
    constructor();
    create(value?: PartialMessage<MonitoringInfoSpec>): MonitoringInfoSpec;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitoringInfoSpec): MonitoringInfoSpec;
    internalBinaryWrite(message: MonitoringInfoSpec, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoSpec
 */
export declare const MonitoringInfoSpec: MonitoringInfoSpec$Type;
declare class Annotation$Type extends MessageType<Annotation> {
    constructor();
    create(value?: PartialMessage<Annotation>): Annotation;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Annotation): Annotation;
    internalBinaryWrite(message: Annotation, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.Annotation
 */
export declare const Annotation: Annotation$Type;
declare class MonitoringInfoSpecs$Type extends MessageType<MonitoringInfoSpecs> {
    constructor();
    create(value?: PartialMessage<MonitoringInfoSpecs>): MonitoringInfoSpecs;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitoringInfoSpecs): MonitoringInfoSpecs;
    internalBinaryWrite(message: MonitoringInfoSpecs, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoSpecs
 */
export declare const MonitoringInfoSpecs: MonitoringInfoSpecs$Type;
declare class MonitoringInfoLabelProps$Type extends MessageType<MonitoringInfoLabelProps> {
    constructor();
    create(value?: PartialMessage<MonitoringInfoLabelProps>): MonitoringInfoLabelProps;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitoringInfoLabelProps): MonitoringInfoLabelProps;
    internalBinaryWrite(message: MonitoringInfoLabelProps, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoLabelProps
 */
export declare const MonitoringInfoLabelProps: MonitoringInfoLabelProps$Type;
declare class MonitoringInfo$Type extends MessageType<MonitoringInfo> {
    constructor();
    create(value?: PartialMessage<MonitoringInfo>): MonitoringInfo;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitoringInfo): MonitoringInfo;
    private binaryReadMap4;
    internalBinaryWrite(message: MonitoringInfo, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfo
 */
export declare const MonitoringInfo: MonitoringInfo$Type;
declare class MonitoringInfoTypeUrns$Type extends MessageType<MonitoringInfoTypeUrns> {
    constructor();
    create(value?: PartialMessage<MonitoringInfoTypeUrns>): MonitoringInfoTypeUrns;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MonitoringInfoTypeUrns): MonitoringInfoTypeUrns;
    internalBinaryWrite(message: MonitoringInfoTypeUrns, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MonitoringInfoTypeUrns
 */
export declare const MonitoringInfoTypeUrns: MonitoringInfoTypeUrns$Type;
export {};
