import type { BinaryWriteOptions } from "@protobuf-ts/runtime";
import type { IBinaryWriter } from "@protobuf-ts/runtime";
import type { BinaryReadOptions } from "@protobuf-ts/runtime";
import type { IBinaryReader } from "@protobuf-ts/runtime";
import type { PartialMessage } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.Schema
 */
export interface Schema {
    /**
     * List of fields for this schema. Two fields may not share a name.
     *
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.Field fields = 1;
     */
    fields: Field[];
    /**
     * REQUIRED. An RFC 4122 UUID.
     *
     * @generated from protobuf field: string id = 2;
     */
    id: string;
    /**
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.Option options = 3;
     */
    options: Option[];
    /**
     * Indicates that encoding positions have been overridden.
     *
     * @generated from protobuf field: bool encoding_positions_set = 4;
     */
    encodingPositionsSet: boolean;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.Field
 */
export interface Field {
    /**
     * REQUIRED. Name of this field within the schema.
     *
     * @generated from protobuf field: string name = 1;
     */
    name: string;
    /**
     * OPTIONAL. Human readable description of this field, such as the query that generated it.
     *
     * @generated from protobuf field: string description = 2;
     */
    description: string;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType type = 3;
     */
    type?: FieldType;
    /**
     * @generated from protobuf field: int32 id = 4;
     */
    id: number;
    /**
     * OPTIONAL. The position of this field's data when encoded, e.g. with beam:coder:row:v1.
     * Either no fields in a given row are have encoding position populated,
     * or all of them are. Used to support backwards compatibility with schema
     * changes.
     * If no fields have encoding position populated the order of encoding is the same as the order in the Schema.
     * If this Field is part of a Schema where encoding_positions_set is True then encoding_position must be
     * defined, otherwise this field is ignored.
     *
     * @generated from protobuf field: int32 encoding_position = 5;
     */
    encodingPosition: number;
    /**
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.Option options = 6;
     */
    options: Option[];
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.FieldType
 */
export interface FieldType {
    /**
     * @generated from protobuf field: bool nullable = 1;
     */
    nullable: boolean;
    /**
     * @generated from protobuf oneof: type_info
     */
    typeInfo: {
        oneofKind: "atomicType";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.AtomicType atomic_type = 2;
         */
        atomicType: AtomicType;
    } | {
        oneofKind: "arrayType";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ArrayType array_type = 3;
         */
        arrayType: ArrayType;
    } | {
        oneofKind: "iterableType";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.IterableType iterable_type = 4;
         */
        iterableType: IterableType;
    } | {
        oneofKind: "mapType";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.MapType map_type = 5;
         */
        mapType: MapType;
    } | {
        oneofKind: "rowType";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.RowType row_type = 6;
         */
        rowType: RowType;
    } | {
        oneofKind: "logicalType";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.LogicalType logical_type = 7;
         */
        logicalType: LogicalType;
    } | {
        oneofKind: undefined;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.ArrayType
 */
export interface ArrayType {
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType element_type = 1;
     */
    elementType?: FieldType;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.IterableType
 */
export interface IterableType {
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType element_type = 1;
     */
    elementType?: FieldType;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MapType
 */
export interface MapType {
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType key_type = 1;
     */
    keyType?: FieldType;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType value_type = 2;
     */
    valueType?: FieldType;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.RowType
 */
export interface RowType {
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.Schema schema = 1;
     */
    schema?: Schema;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.LogicalType
 */
export interface LogicalType {
    /**
     * @generated from protobuf field: string urn = 1;
     */
    urn: string;
    /**
     * @generated from protobuf field: bytes payload = 2;
     */
    payload: Uint8Array;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType representation = 3;
     */
    representation?: FieldType;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType argument_type = 4;
     */
    argumentType?: FieldType;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldValue argument = 5;
     */
    argument?: FieldValue;
}
/**
 * Universally defined Logical types for Row schemas.
 * These logical types are supposed to be understood by all SDKs.
 *
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.LogicalTypes
 */
export interface LogicalTypes {
}
/**
 * @generated from protobuf enum org.apache.beam.model.pipeline.v1.LogicalTypes.Enum
 */
export declare enum LogicalTypes_Enum {
    /**
     * A URN for Python Callable logical type
     *   - Representation type: STRING
     *   - Language type: In Python SDK, PythonCallableWithSource.
     *     In any other SDKs, a wrapper object for a string which
     *     can be evaluated to a Python Callable object.
     *
     * @generated from protobuf enum value: PYTHON_CALLABLE = 0;
     */
    PYTHON_CALLABLE = 0,
    /**
     * A URN for MicrosInstant type
     *   - Representation type: ROW<seconds: INT64, micros: INT64>
     *   - A timestamp without a timezone where seconds + micros represents the
     *     amount of time since the epoch.
     *
     * @generated from protobuf enum value: MICROS_INSTANT = 1;
     */
    MICROS_INSTANT = 1,
    /**
     * A URN for MillisInstant type
     *   - Representation type: INT64
     *   - A timestamp without a timezone represented by the number of
     *     milliseconds since the epoch. The INT64 value is encoded with
     *     big-endian shifted such that lexicographic ordering of the bytes
     *     corresponds to chronological order.
     *
     * @generated from protobuf enum value: MILLIS_INSTANT = 2;
     */
    MILLIS_INSTANT = 2
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.Option
 */
export interface Option {
    /**
     * REQUIRED. Identifier for the option.
     *
     * @generated from protobuf field: string name = 1;
     */
    name: string;
    /**
     * REQUIRED. Type specifier for the structure of value.
     * Conventionally, options that don't require additional configuration should
     * use a boolean type, with the value set to true.
     *
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldType type = 2;
     */
    type?: FieldType;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldValue value = 3;
     */
    value?: FieldValue;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.Row
 */
export interface Row {
    /**
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.FieldValue values = 1;
     */
    values: FieldValue[];
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.FieldValue
 */
export interface FieldValue {
    /**
     * @generated from protobuf oneof: field_value
     */
    fieldValue: {
        oneofKind: "atomicValue";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.AtomicTypeValue atomic_value = 1;
         */
        atomicValue: AtomicTypeValue;
    } | {
        oneofKind: "arrayValue";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.ArrayTypeValue array_value = 2;
         */
        arrayValue: ArrayTypeValue;
    } | {
        oneofKind: "iterableValue";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.IterableTypeValue iterable_value = 3;
         */
        iterableValue: IterableTypeValue;
    } | {
        oneofKind: "mapValue";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.MapTypeValue map_value = 4;
         */
        mapValue: MapTypeValue;
    } | {
        oneofKind: "rowValue";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.Row row_value = 5;
         */
        rowValue: Row;
    } | {
        oneofKind: "logicalTypeValue";
        /**
         * @generated from protobuf field: org.apache.beam.model.pipeline.v1.LogicalTypeValue logical_type_value = 6;
         */
        logicalTypeValue: LogicalTypeValue;
    } | {
        oneofKind: undefined;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.AtomicTypeValue
 */
export interface AtomicTypeValue {
    /**
     * @generated from protobuf oneof: value
     */
    value: {
        oneofKind: "byte";
        /**
         * @generated from protobuf field: int32 byte = 1;
         */
        byte: number;
    } | {
        oneofKind: "int16";
        /**
         * @generated from protobuf field: int32 int16 = 2;
         */
        int16: number;
    } | {
        oneofKind: "int32";
        /**
         * @generated from protobuf field: int32 int32 = 3;
         */
        int32: number;
    } | {
        oneofKind: "int64";
        /**
         * @generated from protobuf field: int64 int64 = 4;
         */
        int64: bigint;
    } | {
        oneofKind: "float";
        /**
         * @generated from protobuf field: float float = 5;
         */
        float: number;
    } | {
        oneofKind: "double";
        /**
         * @generated from protobuf field: double double = 6;
         */
        double: number;
    } | {
        oneofKind: "string";
        /**
         * @generated from protobuf field: string string = 7;
         */
        string: string;
    } | {
        oneofKind: "boolean";
        /**
         * @generated from protobuf field: bool boolean = 8;
         */
        boolean: boolean;
    } | {
        oneofKind: "bytes";
        /**
         * @generated from protobuf field: bytes bytes = 9;
         */
        bytes: Uint8Array;
    } | {
        oneofKind: undefined;
    };
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.ArrayTypeValue
 */
export interface ArrayTypeValue {
    /**
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.FieldValue element = 1;
     */
    element: FieldValue[];
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.IterableTypeValue
 */
export interface IterableTypeValue {
    /**
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.FieldValue element = 1;
     */
    element: FieldValue[];
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MapTypeValue
 */
export interface MapTypeValue {
    /**
     * @generated from protobuf field: repeated org.apache.beam.model.pipeline.v1.MapTypeEntry entries = 1;
     */
    entries: MapTypeEntry[];
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.MapTypeEntry
 */
export interface MapTypeEntry {
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldValue key = 1;
     */
    key?: FieldValue;
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldValue value = 2;
     */
    value?: FieldValue;
}
/**
 * @generated from protobuf message org.apache.beam.model.pipeline.v1.LogicalTypeValue
 */
export interface LogicalTypeValue {
    /**
     * @generated from protobuf field: org.apache.beam.model.pipeline.v1.FieldValue value = 1;
     */
    value?: FieldValue;
}
/**
 * @generated from protobuf enum org.apache.beam.model.pipeline.v1.AtomicType
 */
export declare enum AtomicType {
    /**
     * @generated from protobuf enum value: UNSPECIFIED = 0;
     */
    UNSPECIFIED = 0,
    /**
     * @generated from protobuf enum value: BYTE = 1;
     */
    BYTE = 1,
    /**
     * @generated from protobuf enum value: INT16 = 2;
     */
    INT16 = 2,
    /**
     * @generated from protobuf enum value: INT32 = 3;
     */
    INT32 = 3,
    /**
     * @generated from protobuf enum value: INT64 = 4;
     */
    INT64 = 4,
    /**
     * @generated from protobuf enum value: FLOAT = 5;
     */
    FLOAT = 5,
    /**
     * @generated from protobuf enum value: DOUBLE = 6;
     */
    DOUBLE = 6,
    /**
     * @generated from protobuf enum value: STRING = 7;
     */
    STRING = 7,
    /**
     * @generated from protobuf enum value: BOOLEAN = 8;
     */
    BOOLEAN = 8,
    /**
     * @generated from protobuf enum value: BYTES = 9;
     */
    BYTES = 9
}
declare class Schema$Type extends MessageType<Schema> {
    constructor();
    create(value?: PartialMessage<Schema>): Schema;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Schema): Schema;
    internalBinaryWrite(message: Schema, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.Schema
 */
export declare const Schema: Schema$Type;
declare class Field$Type extends MessageType<Field> {
    constructor();
    create(value?: PartialMessage<Field>): Field;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Field): Field;
    internalBinaryWrite(message: Field, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.Field
 */
export declare const Field: Field$Type;
declare class FieldType$Type extends MessageType<FieldType> {
    constructor();
    create(value?: PartialMessage<FieldType>): FieldType;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: FieldType): FieldType;
    internalBinaryWrite(message: FieldType, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.FieldType
 */
export declare const FieldType: FieldType$Type;
declare class ArrayType$Type extends MessageType<ArrayType> {
    constructor();
    create(value?: PartialMessage<ArrayType>): ArrayType;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ArrayType): ArrayType;
    internalBinaryWrite(message: ArrayType, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.ArrayType
 */
export declare const ArrayType: ArrayType$Type;
declare class IterableType$Type extends MessageType<IterableType> {
    constructor();
    create(value?: PartialMessage<IterableType>): IterableType;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: IterableType): IterableType;
    internalBinaryWrite(message: IterableType, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.IterableType
 */
export declare const IterableType: IterableType$Type;
declare class MapType$Type extends MessageType<MapType> {
    constructor();
    create(value?: PartialMessage<MapType>): MapType;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MapType): MapType;
    internalBinaryWrite(message: MapType, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MapType
 */
export declare const MapType: MapType$Type;
declare class RowType$Type extends MessageType<RowType> {
    constructor();
    create(value?: PartialMessage<RowType>): RowType;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: RowType): RowType;
    internalBinaryWrite(message: RowType, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.RowType
 */
export declare const RowType: RowType$Type;
declare class LogicalType$Type extends MessageType<LogicalType> {
    constructor();
    create(value?: PartialMessage<LogicalType>): LogicalType;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: LogicalType): LogicalType;
    internalBinaryWrite(message: LogicalType, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.LogicalType
 */
export declare const LogicalType: LogicalType$Type;
declare class LogicalTypes$Type extends MessageType<LogicalTypes> {
    constructor();
    create(value?: PartialMessage<LogicalTypes>): LogicalTypes;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: LogicalTypes): LogicalTypes;
    internalBinaryWrite(message: LogicalTypes, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.LogicalTypes
 */
export declare const LogicalTypes: LogicalTypes$Type;
declare class Option$Type extends MessageType<Option> {
    constructor();
    create(value?: PartialMessage<Option>): Option;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Option): Option;
    internalBinaryWrite(message: Option, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.Option
 */
export declare const Option: Option$Type;
declare class Row$Type extends MessageType<Row> {
    constructor();
    create(value?: PartialMessage<Row>): Row;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: Row): Row;
    internalBinaryWrite(message: Row, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.Row
 */
export declare const Row: Row$Type;
declare class FieldValue$Type extends MessageType<FieldValue> {
    constructor();
    create(value?: PartialMessage<FieldValue>): FieldValue;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: FieldValue): FieldValue;
    internalBinaryWrite(message: FieldValue, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.FieldValue
 */
export declare const FieldValue: FieldValue$Type;
declare class AtomicTypeValue$Type extends MessageType<AtomicTypeValue> {
    constructor();
    create(value?: PartialMessage<AtomicTypeValue>): AtomicTypeValue;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: AtomicTypeValue): AtomicTypeValue;
    internalBinaryWrite(message: AtomicTypeValue, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.AtomicTypeValue
 */
export declare const AtomicTypeValue: AtomicTypeValue$Type;
declare class ArrayTypeValue$Type extends MessageType<ArrayTypeValue> {
    constructor();
    create(value?: PartialMessage<ArrayTypeValue>): ArrayTypeValue;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: ArrayTypeValue): ArrayTypeValue;
    internalBinaryWrite(message: ArrayTypeValue, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.ArrayTypeValue
 */
export declare const ArrayTypeValue: ArrayTypeValue$Type;
declare class IterableTypeValue$Type extends MessageType<IterableTypeValue> {
    constructor();
    create(value?: PartialMessage<IterableTypeValue>): IterableTypeValue;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: IterableTypeValue): IterableTypeValue;
    internalBinaryWrite(message: IterableTypeValue, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.IterableTypeValue
 */
export declare const IterableTypeValue: IterableTypeValue$Type;
declare class MapTypeValue$Type extends MessageType<MapTypeValue> {
    constructor();
    create(value?: PartialMessage<MapTypeValue>): MapTypeValue;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MapTypeValue): MapTypeValue;
    internalBinaryWrite(message: MapTypeValue, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MapTypeValue
 */
export declare const MapTypeValue: MapTypeValue$Type;
declare class MapTypeEntry$Type extends MessageType<MapTypeEntry> {
    constructor();
    create(value?: PartialMessage<MapTypeEntry>): MapTypeEntry;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: MapTypeEntry): MapTypeEntry;
    internalBinaryWrite(message: MapTypeEntry, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.MapTypeEntry
 */
export declare const MapTypeEntry: MapTypeEntry$Type;
declare class LogicalTypeValue$Type extends MessageType<LogicalTypeValue> {
    constructor();
    create(value?: PartialMessage<LogicalTypeValue>): LogicalTypeValue;
    internalBinaryRead(reader: IBinaryReader, length: number, options: BinaryReadOptions, target?: LogicalTypeValue): LogicalTypeValue;
    internalBinaryWrite(message: LogicalTypeValue, writer: IBinaryWriter, options: BinaryWriteOptions): IBinaryWriter;
}
/**
 * @generated MessageType for protobuf message org.apache.beam.model.pipeline.v1.LogicalTypeValue
 */
export declare const LogicalTypeValue: LogicalTypeValue$Type;
export {};
