import * as runnerApi from "../proto/beam_runner_api";
import { PTransform } from "./transform";
import { Coder } from "../coders/coders";
import { Window } from "../values";
import { PCollection } from "../pvalue";
import { Pipeline } from "../internal/pipeline";
export interface WindowFn<W extends Window> {
    assignWindows: (Instant: any) => W[];
    windowCoder: () => Coder<W>;
    toProto: () => runnerApi.FunctionSpec;
    isMerging: () => boolean;
    assignsToOneWindow: () => boolean;
    beamName?: string;
}
/** @internal */
export declare function createWindowingStrategyProto(pipeline: Pipeline, windowFn: WindowFn<any>, windowingStrategyBase?: runnerApi.WindowingStrategy | undefined): runnerApi.WindowingStrategy;
/**
 * returns a PTransform that takes an input PCollection and returns an output
 * PCollection with the same elements but a new windowing according to the
 * provided WindowFn.
 *
 * See https://beam.apache.org/documentation/programming-guide/#windowing
 */
export declare function windowInto<T, W extends Window>(windowFn: WindowFn<W>, windowingStrategyBase?: runnerApi.WindowingStrategy | undefined): PTransform<PCollection<T>, PCollection<T>>;
export declare function assignTimestamps<T>(timestampFn: (T: any, Instant: any) => typeof Instant): PTransform<PCollection<T>, PCollection<T>>;
