import Long from "long";
export declare type KV<K, V> = {
    key: K;
    value: V;
};
export declare type Instant = Long;
export interface Window {
    maxTimestamp(): Instant;
}
export declare class GlobalWindow implements Window {
    maxTimestamp(): Instant;
}
export declare class IntervalWindow implements Window {
    start: Instant;
    end: Instant;
    constructor(start: Instant, end: Instant);
    maxTimestamp(): Long.Long;
}
export interface WindowedValue<T> {
    value: T;
    windows: Array<Window>;
    pane: PaneInfo;
    timestamp: Instant;
}
export interface PaneInfo {
    timing: Timing;
    index: number;
    onTimeIndex: number;
    isFirst: boolean;
    isLast: boolean;
}
export declare enum Timing {
    EARLY = "EARLY",
    ON_TIME = "ON_TIME",
    LATE = "LATE",
    UNKNOWN = "UNKNOWN"
}
