import * as grpc from "@grpc/grpc-js";
import { Elements } from "../proto/beam_fn_api";
import { BeamFnDataClient } from "../proto/beam_fn_api.grpc-client";
export declare class MultiplexingDataChannel {
    dataClient: BeamFnDataClient;
    dataChannel: grpc.ClientDuplexStream<Elements, Elements>;
    consumers: Map<string, Map<string, IDataChannel>>;
    constructor(endpoint: string, workerId: string);
    close(): void;
    registerConsumer(bundleId: string, transformId: string, consumer: IDataChannel): Promise<void>;
    unregisterConsumer(bundleId: string, transformId: string): void;
    getConsumer(bundleId: string, transformId: string): IDataChannel;
    getSendChannel(bundleId: string, transformId: string): IDataChannel;
}
export interface IDataChannel {
    sendData: (data: Uint8Array) => Promise<void>;
    sendTimers: (timerFamilyId: string, timers: Uint8Array) => Promise<void>;
    close: () => void;
    onError: (Error: any) => void;
}
