"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function isPrimitive(transform) {
    const inputs = Object.values(transform.inputs);
    if (exports.primitiveSinks.includes(transform?.spec?.urn)) {
        return true;
    }
    else {
        return (transform.subtransforms.length === 0 &&
            Object.values(transform.outputs).some((_tct_transform_1 = (pcoll) => !inputs.includes(pcoll), _tct_transform_1.__closure = () => ({ inputs }), _tct_transform_1)));
    }
}
var _tct_transform_1;
isPrimitive.__closure = () => ({ Object, primitiveSinks: exports.primitiveSinks });
function maybeStripDataflowWindowedWrappings(descriptor) {
    for (const pcoll of Object.values(descriptor.pcollections)) {
        const coder = descriptor.coders[pcoll.coderId];
        if (coder.spec?.urn == "beam:coder:windowed_value:v1" ||
            coder.spec?.urn == "beam:coder:param_windowed_value:v1") {
            // Dataflow sets PCollection coder_id to a coder of WindowedValues rather
            // than the coder of the element type alone.
            // Until Dataflow is fixed, we must assume that the element type is not
            // actually a windowed value, but that this wrapping was extraneously
            // added.
            pcoll.coderId = coder.componentCoderIds[0];
        }
    }
    return descriptor;
}
maybeStripDataflowWindowedWrappings.__closure = () => ({ Object });
Object.defineProperty(exports, "__esModule", { value: true });
exports.primitiveSinks = exports.BundleProcessor = exports.Worker = void 0;
// From sdks/node-ts
//     npx tsc && npm run worker
// From sdks/python
//     python trivial_pipeline.py --environment_type=EXTERNAL --environment_config='localhost:5555' --runner=PortableRunner --job_endpoint=embed
const _tct_flatten_destructured_imports_1 = __importStar(require("@grpc/grpc-js"));
var grpc = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../proto/beam_runner_api"));
var PTransform = _tct_flatten_destructured_imports_2.PTransform;
var PCollection = _tct_flatten_destructured_imports_2.PCollection;
const _tct_flatten_destructured_imports_3 = __importStar(require("../proto/beam_fn_api"));
var InstructionRequest = _tct_flatten_destructured_imports_3.InstructionRequest;
var InstructionResponse = _tct_flatten_destructured_imports_3.InstructionResponse;
const _tct_flatten_destructured_imports_4 = __importStar(require("../proto/beam_fn_api"));
var ProcessBundleDescriptor = _tct_flatten_destructured_imports_4.ProcessBundleDescriptor;
var ProcessBundleResponse = _tct_flatten_destructured_imports_4.ProcessBundleResponse;
var ProcessBundleSplitRequest = _tct_flatten_destructured_imports_4.ProcessBundleSplitRequest;
var ProcessBundleSplitResponse = _tct_flatten_destructured_imports_4.ProcessBundleSplitResponse;
const _tct_flatten_destructured_imports_5 = __importStar(require("../proto/beam_fn_api.grpc-client"));
var BeamFnControlClient = _tct_flatten_destructured_imports_5.BeamFnControlClient;
var IBeamFnControlClient = _tct_flatten_destructured_imports_5.IBeamFnControlClient;
const _tct_flatten_destructured_imports_6 = __importStar(require("../proto/beam_fn_api.grpc-server"));
var beamFnExternalWorkerPoolDefinition = _tct_flatten_destructured_imports_6.beamFnExternalWorkerPoolDefinition;
var IBeamFnExternalWorkerPool = _tct_flatten_destructured_imports_6.IBeamFnExternalWorkerPool;
const _tct_flatten_destructured_imports_7 = __importStar(require("./data"));
var MultiplexingDataChannel = _tct_flatten_destructured_imports_7.MultiplexingDataChannel;
var IDataChannel = _tct_flatten_destructured_imports_7.IDataChannel;
const _tct_flatten_destructured_imports_8 = __importStar(require("./logging"));
var loggingLocalStorage = _tct_flatten_destructured_imports_8.loggingLocalStorage;
var LoggingStageInfo = _tct_flatten_destructured_imports_8.LoggingStageInfo;
const _tct_flatten_destructured_imports_9 = __importStar(require("./metrics"));
var MetricsContainer = _tct_flatten_destructured_imports_9.MetricsContainer;
var MetricsShortIdCache = _tct_flatten_destructured_imports_9.MetricsShortIdCache;
const _tct_flatten_destructured_imports_10 = __importStar(require("./state"));
var MultiplexingStateChannel = _tct_flatten_destructured_imports_10.MultiplexingStateChannel;
var CachingStateProvider = _tct_flatten_destructured_imports_10.CachingStateProvider;
var GrpcStateProvider = _tct_flatten_destructured_imports_10.GrpcStateProvider;
var StateProvider = _tct_flatten_destructured_imports_10.StateProvider;
const _tct_flatten_destructured_imports_11 = __importStar(require("./operators"));
var IOperator = _tct_flatten_destructured_imports_11.IOperator;
var Receiver = _tct_flatten_destructured_imports_11.Receiver;
var createOperator = _tct_flatten_destructured_imports_11.createOperator;
var OperatorContext = _tct_flatten_destructured_imports_11.OperatorContext;
var DataSourceOperator = _tct_flatten_destructured_imports_11.DataSourceOperator;
class Worker {
    constructor(id, endpoints, options = {}) {
        var _tct_transform_2;
        this.id = id;
        this.endpoints = endpoints;
        this.processBundleDescriptors = new Map();
        this.bundleProcessors = new Map();
        this.activeBundleProcessors = new Map();
        this.dataChannels = new Map();
        this.stateChannels = new Map();
        this.metricsShortIdCache = new MetricsShortIdCache();
        const metadata = new grpc.Metadata();
        metadata.add("worker_id", this.id);
        this.controlClient = new BeamFnControlClient(endpoints.controlUrl, grpc.ChannelCredentials.createInsecure(), {}, {});
        this.controlChannel = this.controlClient.control(metadata);
        this.controlChannel.on("data", this.handleRequest.bind(this));
        this.controlChannel.on("end", (_tct_transform_2 = () => {
            console.warn("Control channel closed.");
            for (const dataChannel of this.dataChannels.values()) {
                try {
                    // Best effort.
                    dataChannel.close();
                }
                finally {
                }
            }
            for (const stateChannel of this.stateChannels.values()) {
                try {
                    // Best effort.
                    stateChannel.close();
                }
                finally {
                }
            }
        }, _tct_transform_2.__closure = () => ({ console }), _tct_transform_2));
    }
    async wait() {
        var _tct_transform_3;
        // TODO: Await closing of control log.
        await new Promise((_tct_transform_3 = (r) => setTimeout(r, 1e9), _tct_transform_3.__closure = () => ({ setTimeout }), _tct_transform_3));
    }
    async handleRequest(request) {
        try {
            console.log(request);
            if (request.request.oneofKind === "processBundle") {
                return this.process(request);
            }
            else if (request.request.oneofKind === "processBundleProgress") {
                return this.controlChannel.write(await this.progress(request));
            }
            else if (request.request.oneofKind === "processBundleSplit") {
                return this.controlChannel.write(await this.split(request));
            }
            else {
                console.error("Unknown instruction type: ", request);
                return this.controlChannel.write({
                    instructionId: request.instructionId,
                    error: "Unknown instruction type: " + request.request.oneofKind,
                    response: {
                        oneofKind: undefined,
                    },
                });
            }
        }
        catch (e) {
            return this.controlChannel.write({
                instructionId: request.instructionId,
                error: "Error handling instruction: " + e + "\n" + e.stack,
                response: {
                    oneofKind: undefined,
                },
            });
        }
    }
    async respond(response) {
        return this.controlChannel.write(response);
    }
    async progress(request) {
        const processor = this.activeBundleProcessors.get(request.request.processBundleProgress.instructionId);
        if (processor) {
            const monitoringData = processor.monitoringData(this.metricsShortIdCache);
            return {
                instructionId: request.instructionId,
                error: "",
                response: {
                    oneofKind: "processBundleProgress",
                    processBundleProgress: {
                        monitoringInfos: Array.from(monitoringData.entries()).map(([id, payload]) => this.metricsShortIdCache.asMonitoringInfo(id, payload)),
                        monitoringData: Object.fromEntries(monitoringData.entries()),
                    },
                },
            };
        }
        else {
            return {
                instructionId: request.instructionId,
                error: "Unknown bundle: " + request.processBundleProgress.instructionId,
                response: {
                    oneofKind: undefined,
                },
            };
        }
    }
    async split(request) {
        const processor = this.activeBundleProcessors.get(request.request.processBundleSplit.instructionId);
        console.log(request.request.processBundleSplit, processor === undefined);
        if (processor) {
            return {
                instructionId: request.instructionId,
                error: "",
                response: {
                    oneofKind: "processBundleSplit",
                    processBundleSplit: processor.split(request.request.processBundleSplit),
                },
            };
        }
        else {
            return {
                instructionId: request.instructionId,
                error: "Unknown process bundle: " +
                    request.request.processBundleSplit.instructionId,
                response: {
                    oneofKind: undefined,
                },
            };
        }
    }
    async process(request) {
        var _tct_transform_4;
        const descriptorId = request.request.processBundle.processBundleDescriptorId;
        try {
            if (!this.processBundleDescriptors.has(descriptorId)) {
                const call = this.controlClient.getProcessBundleDescriptor({
                    processBundleDescriptorId: descriptorId,
                }, (_tct_transform_4 = (err, value) => {
                    if (err) {
                        this.respond({
                            instructionId: request.instructionId,
                            error: "" + err,
                            response: {
                                oneofKind: "processBundle",
                                processBundle: {
                                    residualRoots: [],
                                    monitoringInfos: [],
                                    requiresFinalization: false,
                                    monitoringData: {},
                                },
                            },
                        });
                    }
                    else {
                        this.processBundleDescriptors.set(descriptorId, maybeStripDataflowWindowedWrappings(value));
                        this.process(request);
                    }
                }, _tct_transform_4.__closure = () => ({ request, descriptorId, maybeStripDataflowWindowedWrappings }), _tct_transform_4));
                return;
            }
            const processor = this.aquireBundleProcessor(descriptorId);
            this.activeBundleProcessors.set(request.instructionId, processor);
            await processor.process(request.instructionId);
            const monitoringData = processor.monitoringData(this.metricsShortIdCache);
            await this.respond({
                instructionId: request.instructionId,
                error: "",
                response: {
                    oneofKind: "processBundle",
                    processBundle: {
                        residualRoots: [],
                        requiresFinalization: false,
                        monitoringInfos: Array.from(monitoringData.entries()).map(([id, payload]) => this.metricsShortIdCache.asMonitoringInfo(id, payload)),
                        monitoringData: Object.fromEntries(monitoringData.entries()),
                    },
                },
            });
            this.returnBundleProcessor(processor);
        }
        catch (error) {
            console.error("PROCESS ERROR", error);
            await this.respond({
                instructionId: request.instructionId,
                error: "" + error,
                response: { oneofKind: undefined },
            });
        }
        finally {
            this.activeBundleProcessors.delete(request.instructionId);
        }
    }
    aquireBundleProcessor(descriptorId) {
        if (!this.bundleProcessors.has(descriptorId)) {
            this.bundleProcessors.set(descriptorId, []);
        }
        const processor = this.bundleProcessors.get(descriptorId)?.pop();
        if (processor) {
            return processor;
        }
        else {
            return new BundleProcessor(this.processBundleDescriptors.get(descriptorId), this.getDataChannel.bind(this), this.getStateChannel.bind(this));
        }
    }
    returnBundleProcessor(processor) {
        if (!this.bundleProcessors.has(processor.descriptor.id)) {
            this.bundleProcessors.set(processor.descriptor.id, []);
        }
        this.bundleProcessors.get(processor.descriptor.id).push(processor);
    }
    getDataChannel(endpoint) {
        // TODO: (Typescript) Defining something like Python's defaultdict could
        // simplify this code.
        // This would be handy in several other places as well.
        if (!this.dataChannels.has(endpoint)) {
            this.dataChannels.set(endpoint, new MultiplexingDataChannel(endpoint, this.id));
        }
        return this.dataChannels.get(endpoint);
    }
    getStateChannel(endpoint) {
        if (!this.stateChannels.has(endpoint)) {
            this.stateChannels.set(endpoint, new MultiplexingStateChannel(endpoint, this.id));
        }
        return this.stateChannels.get(endpoint);
    }
    stop() {
        this.controlChannel.end();
    }
}
exports.Worker = Worker;
class BundleProcessor {
    constructor(descriptor, getDataChannel, getStateChannel, root_urns = ["beam:runner:source:v1"]) {
        function getReceiver(pcollectionId) {
            if (!this_.receivers.has(pcollectionId)) {
                this_.receivers.set(pcollectionId, new Receiver((consumers.get(pcollectionId) || []).map(getOperator), this_.loggingStageInfo, this_.metricsContainer.elementCountMetric(pcollectionId)));
            }
            return this_.receivers.get(pcollectionId);
        }
        var _tct_transform_5, _tct_transform_6;
        getReceiver.__closure = () => ({ this_, Receiver, consumers, getOperator });
        function getOperator(transformId) {
            if (!this_.operators.has(transformId)) {
                this_.operators.set(transformId, createOperator(transformId, new OperatorContext(descriptor, getReceiver, this_.getDataChannel, this_.getStateProvider.bind(this_), this_.getBundleId.bind(this_), this_.loggingStageInfo, this_.metricsContainer)));
                creationOrderedOperators.push(this_.operators.get(transformId));
            }
            return this_.operators.get(transformId);
        }
        getOperator.__closure = () => ({ this_, createOperator, OperatorContext, descriptor, getReceiver, creationOrderedOperators });
        this.topologicallyOrderedOperators = [];
        this.operators = new Map();
        this.receivers = new Map();
        this.loggingStageInfo = {};
        this.descriptor = descriptor;
        this.getDataChannel = getDataChannel;
        this.getStateChannel = getStateChannel;
        this.metricsContainer = new MetricsContainer();
        // TODO: (Perf) Consider defering this possibly expensive deserialization lazily to the worker thread.
        const this_ = this;
        const creationOrderedOperators = [];
        const consumers = new Map();
        Object.entries(descriptor.transforms).forEach((_tct_transform_5 = ([transformId, transform]) => {
            var _tct_transform_7;
            if (isPrimitive(transform)) {
                Object.values(transform.inputs).forEach((_tct_transform_7 = (pcollectionId) => {
                    if (!consumers.has(pcollectionId)) {
                        consumers.set(pcollectionId, []);
                    }
                    consumers.get(pcollectionId).push(transformId);
                }, _tct_transform_7.__closure = () => ({ consumers, transformId }), _tct_transform_7));
            }
        }, _tct_transform_5.__closure = () => ({ isPrimitive, Object, consumers }), _tct_transform_5));
        Object.entries(descriptor.transforms).forEach((_tct_transform_6 = ([transformId, transform]) => {
            if (root_urns.includes(transform?.spec?.urn)) {
                getOperator(transformId);
            }
        }, _tct_transform_6.__closure = () => ({ root_urns, getOperator }), _tct_transform_6));
        this.topologicallyOrderedOperators = creationOrderedOperators.reverse();
    }
    getStateProvider() {
        if (!this.stateProvider) {
            if (typeof this.getStateChannel === "function") {
                this.stateProvider = new CachingStateProvider(new GrpcStateProvider(this.getStateChannel(this.descriptor.stateApiServiceDescriptor.url), this.getBundleId()));
            }
            else {
                this.stateProvider = this.getStateChannel;
            }
        }
        return this.stateProvider;
    }
    getBundleId() {
        if (this.currentBundleId === null || this.currentBundleId === undefined) {
            throw new Error("Not currently processing a bundle.");
        }
        return this.currentBundleId;
    }
    // Put this on a worker thread...
    async process(instructionId) {
        console.debug("Processing ", this.descriptor.id, "for", instructionId);
        this.metricsContainer.reset();
        this.currentBundleId = instructionId;
        this.loggingStageInfo.instructionId = instructionId;
        loggingLocalStorage.enterWith(this.loggingStageInfo);
        // We must await these in reverse topological order.
        for (const o of this.topologicallyOrderedOperators.slice().reverse()) {
            this.loggingStageInfo.transformId = o.transformId;
            await o.startBundle();
        }
        this.loggingStageInfo.transformId = undefined;
        // Now finish bundles all the bundles.
        // Note that process is not directly called on any operator here.
        // Instead, process is triggered by elements coming over the
        // data stream and/or operator start/finishBundle methods.
        for (const o of this.topologicallyOrderedOperators) {
            this.loggingStageInfo.transformId = o.transformId;
            await o.finishBundle();
        }
        this.loggingStageInfo.transformId = undefined;
        this.loggingStageInfo.instructionId = undefined;
        this.currentBundleId = undefined;
        this.stateProvider = undefined;
    }
    split(splitRequest) {
        const root = this.topologicallyOrderedOperators[0];
        for (const [target, desiredSplit] of Object.entries(splitRequest.desiredSplits)) {
            if (target == root.transformId) {
                const channelSplit = root.split(desiredSplit);
                if (channelSplit) {
                    return {
                        primaryRoots: [],
                        residualRoots: [],
                        channelSplits: [channelSplit],
                    };
                }
            }
        }
        return ProcessBundleSplitResponse.create({});
    }
    monitoringData(shortIdCache) {
        return this.metricsContainer.monitoringData(shortIdCache);
    }
}
exports.BundleProcessor = BundleProcessor;
exports.primitiveSinks = ["beam:runner:sink:v1"];
//# sourceMappingURL=worker.js.map