"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _tct_transform_1;
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const os = require("os");
const path = require("path");
const _tct_flatten_destructured_imports_1 = __importStar(require("../src/apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../src/apache_beam/testing/assert"));
var testing = _tct_flatten_destructured_imports_2;
const _tct_flatten_destructured_imports_3 = __importStar(require("../runners/runner"));
var createRunner = _tct_flatten_destructured_imports_3.createRunner;
const _tct_flatten_destructured_imports_4 = __importStar(require("../src/apache_beam/io/textio"));
var textio = _tct_flatten_destructured_imports_4;
describe("IO Tests", (_tct_transform_1 = function () {
    var _tct_transform_2;
    it("textio test", (_tct_transform_2 = async function () {
        var _tct_transform_3, _tct_transform_4;
        const elements = [
            "In the beginning God created the heaven and the earth.",
            "And the earth was without form, and void; and darkness was upon the face of the deep.",
            "And the Spirit of God moved upon the face of the waters.",
            "And God said, Let there be light: and there was light.",
        ];
        const tempDir = fs.mkdtempSync(os.tmpdir(), "apache-beam-test");
        await createRunner().run((_tct_transform_3 = (root) => {
            await root //
                .apply(new beam.Create(elements))
                .asyncApply(textio.WriteToText(os.join(tempDir, "out.txt")));
        }, _tct_transform_3.__closure = () => ({ beam, elements, textio, os, tempDir }), _tct_transform_3));
        await createRunner().run((_tct_transform_4 = (root) => {
            (await root.asyncApply(textio.ReadFromText(os.join(tempDir, "out.txt*")))).apply(testing.AssertDeepEqual(elements));
        }, _tct_transform_4.__closure = () => ({ textio, os, tempDir, testing, elements }), _tct_transform_4));
    }, _tct_transform_2.__closure = () => ({ fs, os, createRunner, beam, textio, testing }), _tct_transform_2));
}, _tct_transform_1.__closure = () => ({ it, fs, os, createRunner, beam, textio, testing }), _tct_transform_1));
//# sourceMappingURL=io_test.js.map