"use strict";
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
function wordCount(lines) {
    return lines
        .map((s) => s.toLowerCase())
        .flatMap(function* splitWords(line) {
        yield* line.split(/[^a-z]+/);
    })
        .apply(beam.countPerElement());
}
var _tct_transform_1;
wordCount.__closure = () => ({ beam });
Object.defineProperty(exports, "__esModule", { value: true });
const _tct_flatten_destructured_imports_1 = __importStar(require("../src/apache_beam"));
var beam = _tct_flatten_destructured_imports_1;
const _tct_flatten_destructured_imports_2 = __importStar(require("../src/apache_beam/runners/direct_runner"));
var directRunner = _tct_flatten_destructured_imports_2.directRunner;
const _tct_flatten_destructured_imports_3 = __importStar(require("../src/apache_beam/testing/assert"));
var testing = _tct_flatten_destructured_imports_3;
const _tct_flatten_destructured_imports_4 = __importStar(require("../src/apache_beam/runners/portable_runner/runner"));
var PortableRunner = _tct_flatten_destructured_imports_4.PortableRunner;
describe("wordcount", (_tct_transform_1 = function () {
    var _tct_transform_2, _tct_transform_3;
    it("wordcount", (_tct_transform_2 = async function () {
        var _tct_transform_4;
        await directRunner().run((_tct_transform_4 = (root) => {
            const lines = root.apply(beam.create([
                "In the beginning God created the heaven and the earth.",
                "And the earth was without form, and void; and darkness was upon the face of the deep.",
                "And the Spirit of God moved upon the face of the waters.",
                "And God said, Let there be light: and there was light.",
            ]));
            lines.apply(wordCount).map(console.log);
        }, _tct_transform_4.__closure = () => ({ beam, wordCount, console }), _tct_transform_4));
    }, _tct_transform_2.__closure = () => ({ directRunner, beam, wordCount, console }), _tct_transform_2));
    it("wordcount assert", (_tct_transform_3 = async function () {
        var _tct_transform_5;
        await directRunner().run((_tct_transform_5 = (root) => {
            const lines = root.apply(beam.create(["And God said, Let there be light: and there was light"]));
            lines.apply(wordCount).apply(testing.assertDeepEqual([
                { element: "and", count: 2 },
                { element: "god", count: 1 },
                { element: "said", count: 1 },
                { element: "let", count: 1 },
                { element: "there", count: 2 },
                { element: "be", count: 1 },
                { element: "light", count: 2 },
                { element: "was", count: 1 },
            ]));
        }, _tct_transform_5.__closure = () => ({ beam, wordCount, testing }), _tct_transform_5));
    }, _tct_transform_3.__closure = () => ({ directRunner, beam, wordCount, testing }), _tct_transform_3));
}, _tct_transform_1.__closure = () => ({ it, directRunner, beam, wordCount, console, testing }), _tct_transform_1));
//# sourceMappingURL=wordcount.js.map